﻿Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices
Imports System.Math
Public Class cls_ImageConversion
    'Private CharacterColor_R(2048) As Byte 'larger then 2048 characters one one screen of a CBM computer is unthinkable... (so we are OK)
    'Private CharacterColor_G(2048) As Byte 'larger then 2048 characters one one screen of a CBM computer is unthinkable... (so we are OK)
    'Private CharacterColor_B(2048) As Byte 'larger then 2048 characters one one screen of a CBM computer is unthinkable... (so we are OK)

    'Call example:  PictureBox2.Image = ResizeHighQuality(PictureBox1.Image, 320,200)
    Public Function ResizeHighQualityTo(ByVal bmp As Bitmap, ByVal width As Integer, ByVal height As Integer) As Bitmap
        'before we do anything, check if conversion is required
        If (bmp.Width = width) And (bmp.Height = height) Then
            'Debug.Print("Resize not required")
            Return bmp  'image does not need to be resized
        End If

        Dim newBit As New Bitmap(width, height) 'new blank bitmap
        Dim g As Graphics = Graphics.FromImage(newBit)
        'change interpolation for reduction quality
        g.InterpolationMode = Drawing2D.InterpolationMode.HighQualityBicubic
        g.DrawImage(bmp, 0, 0, width, height)
        Return newBit
    End Function

    Public Function ChangeBrightnessContrast(ByVal bmp As Bitmap, ByVal bright As Integer, ByVal contr As Integer) As Bitmap
        Dim brightness As Single = CSng(bright / 100) ' 0F = no change in brightness
        Dim contrast As Single = CSng(contr / 100) '1.0F = no change in contrast

        Dim adjustedBrightness As Single = brightness
        'create matrix that will brighten and contrast the image
        Dim image_attr As New ImageAttributes
        Dim cm As ColorMatrix = New ColorMatrix(New Single()() {New Single() {contrast, 0.0, 0.0, 0.0, 0.0}, New Single() {0.0, contrast, 0.0, 0.0, 0.0}, New Single() {0.0, 0.0, contrast, 0.0, 0.0}, New Single() {0.0, 0.0, 0.0, 1.0, 0.0}, New Single() {adjustedBrightness, adjustedBrightness, adjustedBrightness, 0.0, 1.0}})
        Dim rect As Rectangle = Rectangle.Round(bmp.GetBounds(GraphicsUnit.Pixel))
        Dim wid As Integer = bmp.Width
        Dim hgt As Integer = bmp.Height

        Dim img As New Bitmap(wid, hgt)
        Dim gr As Graphics = Graphics.FromImage(img)

        image_attr.SetColorMatrix(cm)
        gr.DrawImage(bmp, rect, 0, 0, wid, hgt, GraphicsUnit.Pixel, image_attr)

        ChangeBrightnessContrast = img
    End Function

    'convert a color bitmap into a grayscale bitmap
    Public Function ToGrayscale(ByVal bmp As Bitmap, ByVal sourcecolor As Integer) As Bitmap
        Dim pxf As PixelFormat = PixelFormat.Format24bppRgb                             'Specify a pixel format.
        Dim rect As Rectangle = New Rectangle(0, 0, bmp.Width, bmp.Height)              'Lock the bitmap's bits.
        Dim bmpData As BitmapData = bmp.LockBits(rect, ImageLockMode.ReadWrite, pxf)
        Dim ptr As IntPtr = bmpData.Scan0                                               'Get the address of the first line of the bitmap.
        Dim data As Byte
        Dim numBytes As Integer = bmp.Width * bmp.Height * 3                            'Declare an array to hold the bytes of the bitmap.
        Dim rgbValues(numBytes - 1) As Byte
        Dim luminance As Long

        Marshal.Copy(ptr, rgbValues, 0, numBytes)                                       'Copy the RGB values into the array.

        'Manipulate the bitmap
        For i As Integer = 0 To rgbValues.Length - 1 Step 3
            Select Case (sourcecolor)
                Case 0 'grayscale
                    luminance = (rgbValues(i + 2) * 0.299) + (rgbValues(i + 1) * 0.587) + (rgbValues(i + 0) * 0.114) 'red * 0.299 + green * 0.587 + blue * 0.114
                    data = Convert.ToByte(luminance)

                Case 1 'red
                    data = rgbValues(i + 2) 'use the red channel

                Case 2 'green
                    data = rgbValues(i + 1) 'use the green channel

                Case 3 'blue
                    data = rgbValues(i + 0) 'use the blue channel

            End Select

            rgbValues(i + 2) = data ' R
            rgbValues(i + 1) = data ' G
            rgbValues(i + 0) = data ' B
        Next i


        Marshal.Copy(rgbValues, 0, ptr, numBytes)                                       'Copy the RGB values back to the bitmap
        bmp.UnlockBits(bmpData)                                                         'Unlock the bits.
        Return (bmp)
    End Function

    'dithering, just like floyd... but with slightly less noticable artifacts
    Public Function ToBW_Burkes(ByVal bmp As Bitmap, ByVal sourcecolor As Integer, ByVal DitherHardness As Integer) As Bitmap
        bmp = ToGrayscale(bmp, sourcecolor)  'first we make the BMP gray (easier to work with)

        Dim err As Double
        'ditherhardness is a value between 0-255 (value should be 16 for normal operation)
        'Stucki spreads the error of a pixel conversion around the area of the pixels with the following ratios
        '	 ....     ....     PIXEL    8/32    4/32
        '	 2/32     4/32     8/32     4/32    2/32


        Dim pxf As PixelFormat = PixelFormat.Format24bppRgb                             'Specify a pixel format.
        Dim rect As Rectangle = New Rectangle(0, 0, bmp.Width, bmp.Height)              'Lock the bitmap's bits.
        Dim bmpData As BitmapData = bmp.LockBits(rect, ImageLockMode.ReadWrite, pxf)
        Dim ptr As IntPtr = bmpData.Scan0                                               'Get the address of the first line of the bitmap.
        Dim numBytes As Integer = bmp.Width * bmp.Height * 3                            'Declare an array to hold the bytes of the bitmap.
        Dim rgbValues(numBytes - 1) As Byte
        Dim pixeladdress As Integer
        Dim pixaddr As Integer
        Const pixel As Integer = 3  'pixel consist of 3 bytes
        Dim old_pixel_value As Byte

        Dim thresshold As Byte = 128     'thresshold is at half the range of a byte
        Dim charcolpntr As Integer

        Dim col_cnt(8) As Integer

        Marshal.Copy(ptr, rgbValues, 0, numBytes)                                       'Copy the RGB values into the array.

        pixeladdress = -pixel
        For Y As Integer = 0 To (bmp.Height - 1)
            For X As Integer = 0 To (bmp.Width - 1)
                pixeladdress = pixeladdress + pixel
                old_pixel_value = rgbValues(pixeladdress)

                charcolpntr = (X \ 8) + ((Y \ 8) * (bmp.Width / 8))

                If (rgbValues(pixeladdress) >= thresshold) Then
                    rgbValues(pixeladdress + 2) = &HFF
                    rgbValues(pixeladdress + 1) = &HFF
                    rgbValues(pixeladdress + 0) = &HFF
                Else
                    rgbValues(pixeladdress + 2) = &H0
                    rgbValues(pixeladdress + 1) = &H0
                    rgbValues(pixeladdress + 0) = &H0
                End If

                err = (Convert.ToInt16(old_pixel_value) - Convert.ToInt16(rgbValues(pixeladdress))) / ((DitherHardness / 2) + 16)        '32=default, higher makes the result "harder"

                If (X + 1 <= (bmp.Width - 2)) Then      'check if there are two right neighbour pixels
                    rgbValues(pixeladdress + pixel) = AddError(rgbValues(pixeladdress + pixel), 8 * err)
                    rgbValues(pixeladdress + (2 * pixel)) = AddError(rgbValues(pixeladdress + (2 * pixel)), 4 * err)
                End If

                If (Y + 1 <= (bmp.Height - 1)) Then     'check if there is a line below
                    pixaddr = pixeladdress + (pixel * bmp.Width)   'calculate pixel addres for the next line
                    If (X - 2 >= 0) Then                'check if there is a pixel to the left
                        rgbValues(pixaddr - pixel) = AddError(rgbValues(pixaddr - pixel), 2 * err)
                        rgbValues(pixaddr - (2 * pixel)) = AddError(rgbValues(pixaddr - (2 * pixel)), 4 * err)
                    End If

                    'the line exists therfore this pixel exists
                    rgbValues(pixaddr) = AddError(rgbValues(pixaddr), 8 * err)

                    If (X + 2 <= (bmp.Width - 1)) Then  'check if there is a pixel to the right
                        rgbValues(pixaddr + pixel) = AddError(rgbValues(pixaddr + pixel), 4 * err)
                        rgbValues(pixaddr + (2 * pixel)) = AddError(rgbValues(pixaddr + (2 * pixel)), 2 * err)
                    End If
                End If

            Next X
        Next Y

        Marshal.Copy(rgbValues, 0, ptr, numBytes)                                       'Copy the RGB values back to the bitmap
        bmp.UnlockBits(bmpData)                                                         'Unlock the bits.
        Return (bmp)
    End Function

    'helper function for floyd-steinberg conversion
    Private Function AddError(ByVal pixelvalue As Byte, ByVal err As Double) As Byte
        'this function calculates the new pixelvalue clamped to 0 or 255 value (if required)
        Dim result As Double

        result = Convert.ToInt16(pixelvalue) + err  'determine new value

        If (result > 255) Then                      'check if clamping required
            result = 255
        End If

        If (result < 0) Then                        'check if clamping required
            result = 0
        End If

        Return (Convert.ToByte(result))             'return the result of the calculation clamped if required	
    End Function


    '=====================================================================================================================
    '                                            U N U S E D   C O D E
    '=====================================================================================================================

    'Here are some functions used to add color to the 8x8 pixel cells. But due to the low number of blocks per frame, the
    'result is simply confusing. Adding color using only 8 possible colors (actually 6 because balck and white are already available in b/w highres)
    'B/W is less anoying/distracting to watch then blocky inaccurate colors

    'It would make more sense to manually add color in the areas where it would make sense




    ''determine the average colors of the bitmap of a block of 8x8 pixels
    ''output is in the form of a bitmap (for debugging) and to an arry for further processing
    ''the debug flag should be set to FALSE, unless we want to display the result in the form of a BMP and show that in a picturebox for debugging
    'Public Function Determine8x8AverageCol(ByVal bmp As Bitmap, ByVal dbg As Boolean) As Bitmap
    '    Dim pxf As PixelFormat = PixelFormat.Format24bppRgb                             'Specify a pixel format.
    '    Dim rect As Rectangle = New Rectangle(0, 0, bmp.Width, bmp.Height)              'Lock the bitmap's bits.
    '    Dim bmpData As BitmapData = bmp.LockBits(rect, ImageLockMode.ReadWrite, pxf)
    '    Dim ptr As IntPtr = bmpData.Scan0                                               'Get the address of the first line of the bitmap.
    '    Dim numBytes As Integer = bmp.Width * bmp.Height * 3                            'Declare an array to hold the bytes of the bitmap.
    '    Dim rgbValues(numBytes - 1) As Byte
    '    Dim tmp0 As Integer
    '    Dim tmp1 As Integer
    '    Dim i As Integer
    '    Dim y As Integer
    '    Dim x As Integer
    '    Dim p As Integer
    '    Dim average_r As UInt16
    '    Dim average_g As UInt16
    '    Dim average_b As UInt16
    '    Dim temp_r As UInt16
    '    Dim temp_g As UInt16
    '    Dim temp_b As UInt16
    '    Dim charcolpntr As Integer
    '    Dim prev_distance As Double
    '    Dim cur_distance As Double
    '    'source: https://lospec.com/palette-list/commodore-vic-20
    '    'Dim palette_r() As Byte = {&H0, &HFF, &H77, &H85, &HA8, &H55, &H42, &HBD}
    '    'Dim palette_g() As Byte = {&H0, &HFF, &H2D, &HD4, &H5F, &H9E, &H34, &HCC}
    '    'Dim palette_b() As Byte = {&H0, &HFF, &H26, &HDC, &HB4, &H4A, &H8B, &H71}

    '    'source: http://computingvoyage.com/613/the-palette-color-matcher/
    '    Dim palette_r() As Byte = {&H0, &HFF, &H78, &H87, &HA9, &H56, &H40, &HBF}
    '    Dim palette_g() As Byte = {&H0, &HFF, &H29, &HD6, &H5F, &HA0, &H31, &HCE}
    '    Dim palette_b() As Byte = {&H0, &HFF, &H22, &HDD, &HB6, &H4A, &H8E, &H73}



    '    Marshal.Copy(ptr, rgbValues, 0, numBytes)                                       'Copy the RGB values into the array.

    '    'generate all tiles (simple copy from the bitmap to an array)
    '    For y = 0 To (bmp.Height - 1) Step 8
    '        tmp0 = (y * bmp.Width)
    '        For x = 0 To (bmp.Width - 1) Step 8
    '            tmp1 = x + tmp0

    '            'calculate average red, green and blue (from a 8x8 grid)
    '            average_r = 0
    '            average_g = 0
    '            average_b = 0
    '            For kar = 0 To 7
    '                i = tmp1 + (kar * bmp.Width)
    '                average_r = average_r + rgbValues(((i + 0) * 3) + 2) '+2 to get RED data
    '                average_r = average_r + rgbValues(((i + 1) * 3) + 2) '+2 to get RED data
    '                average_r = average_r + rgbValues(((i + 2) * 3) + 2) '+2 to get RED data
    '                average_r = average_r + rgbValues(((i + 3) * 3) + 2) '+2 to get RED data
    '                average_r = average_r + rgbValues(((i + 4) * 3) + 2) '+2 to get RED data
    '                average_r = average_r + rgbValues(((i + 5) * 3) + 2) '+2 to get RED data
    '                average_r = average_r + rgbValues(((i + 6) * 3) + 2) '+2 to get RED data
    '                average_r = average_r + rgbValues(((i + 7) * 3) + 2) '+2 to get RED data

    '                average_g = average_g + rgbValues(((i + 0) * 3) + 1) '+1 to get GREEN data
    '                average_g = average_g + rgbValues(((i + 1) * 3) + 1) '+1 to get GREEN data
    '                average_g = average_g + rgbValues(((i + 2) * 3) + 1) '+1 to get GREEN data
    '                average_g = average_g + rgbValues(((i + 3) * 3) + 1) '+1 to get GREEN data
    '                average_g = average_g + rgbValues(((i + 4) * 3) + 1) '+1 to get GREEN data
    '                average_g = average_g + rgbValues(((i + 5) * 3) + 1) '+1 to get GREEN data
    '                average_g = average_g + rgbValues(((i + 6) * 3) + 1) '+1 to get GREEN data
    '                average_g = average_g + rgbValues(((i + 7) * 3) + 1) '+1 to get GREEN data

    '                average_b = average_b + rgbValues(((i + 0) * 3) + 0) '+0 to get BLUE data
    '                average_b = average_b + rgbValues(((i + 1) * 3) + 0) '+0 to get BLUE data
    '                average_b = average_b + rgbValues(((i + 2) * 3) + 0) '+0 to get BLUE data
    '                average_b = average_b + rgbValues(((i + 3) * 3) + 0) '+0 to get BLUE data
    '                average_b = average_b + rgbValues(((i + 4) * 3) + 0) '+0 to get BLUE data
    '                average_b = average_b + rgbValues(((i + 5) * 3) + 0) '+0 to get BLUE data
    '                average_b = average_b + rgbValues(((i + 6) * 3) + 0) '+0 to get BLUE data
    '                average_b = average_b + rgbValues(((i + 7) * 3) + 0) '+0 to get BLUE data

    '            Next kar
    '            average_r = average_r / 64
    '            average_g = average_g / 64
    '            average_b = average_b / 64

    '            'now that we have the average color of an 8x8 block we must find the closest matching color from the computers palette
    '            prev_distance = 10000
    '            cur_distance = 10000
    '            temp_r = 0
    '            temp_g = 0
    '            temp_b = 0

    '            'loop through the table of all possible colors
    '            For p = 0 To 7
    '                cur_distance = ColourDistance(CByte(average_r), palette_r(p), CByte(average_g), palette_g(p), CByte(average_b), palette_b(p))
    '                If (cur_distance < prev_distance) Then
    '                    temp_r = palette_r(p)
    '                    temp_g = palette_g(p)
    '                    temp_b = palette_b(p)
    '                    prev_distance = cur_distance
    '                End If
    '            Next p
    '            average_r = temp_r
    '            average_g = temp_g
    '            average_b = temp_b


    '            If (dbg = True) Then
    '                'write the average color to the colors of the bitmap
    '                For kar = 0 To 7
    '                    i = tmp1 + (kar * bmp.Width)
    '                    rgbValues(((i + 0) * 3) + 2) = average_r    'R
    '                    rgbValues(((i + 1) * 3) + 2) = average_r    'R
    '                    rgbValues(((i + 2) * 3) + 2) = average_r    'R
    '                    rgbValues(((i + 3) * 3) + 2) = average_r    'R
    '                    rgbValues(((i + 4) * 3) + 2) = average_r    'R
    '                    rgbValues(((i + 5) * 3) + 2) = average_r    'R
    '                    rgbValues(((i + 6) * 3) + 2) = average_r    'R
    '                    rgbValues(((i + 7) * 3) + 2) = average_r    'R

    '                    rgbValues(((i + 0) * 3) + 1) = average_g    'G
    '                    rgbValues(((i + 1) * 3) + 1) = average_g    'G
    '                    rgbValues(((i + 2) * 3) + 1) = average_g    'G
    '                    rgbValues(((i + 3) * 3) + 1) = average_g    'G
    '                    rgbValues(((i + 4) * 3) + 1) = average_g    'G
    '                    rgbValues(((i + 5) * 3) + 1) = average_g    'G
    '                    rgbValues(((i + 6) * 3) + 1) = average_g    'G
    '                    rgbValues(((i + 7) * 3) + 1) = average_g    'G

    '                    rgbValues(((i + 0) * 3) + 0) = average_b    'B
    '                    rgbValues(((i + 1) * 3) + 0) = average_b    'B
    '                    rgbValues(((i + 2) * 3) + 0) = average_b    'B
    '                    rgbValues(((i + 3) * 3) + 0) = average_b    'B
    '                    rgbValues(((i + 4) * 3) + 0) = average_b    'B
    '                    rgbValues(((i + 5) * 3) + 0) = average_b    'B
    '                    rgbValues(((i + 6) * 3) + 0) = average_b    'B
    '                    rgbValues(((i + 7) * 3) + 0) = average_b    'B
    '                Next kar
    '            End If

    '            'Debug.Print("charcolpntr = " & charcolpntr & ", R=" & average_r & ", G=" & average_g & ", B=" & average_b)

    '            CharacterColor_R(charcolpntr) = average_r
    '            CharacterColor_G(charcolpntr) = average_g
    '            CharacterColor_B(charcolpntr) = average_b
    '            charcolpntr = charcolpntr + 1

    '        Next x
    '    Next y

    '    If (dbg = True) Then
    '        Marshal.Copy(rgbValues, 0, ptr, numBytes)                                       'Copy the RGB values back to the bitmap            
    '    End If

    '    bmp.UnlockBits(bmpData)                                                         'Unlock the bits.
    '    Return (bmp)

    'End Function


    ''The code below was found on: <source>
    'Public Function ColourDistance(ByVal R1 As Byte, ByVal R2 As Byte, ByVal B1 As Byte, ByVal B2 As Byte, ByVal G1 As Byte, ByVal G2 As Byte) As Double
    '    Dim rmean As Long = (CLng(R1) + CLng(R2)) / 2
    '    Dim r As Long = CLng(R1) - CLng(R2)
    '    Dim g As Long = CLng(G1) - CLng(G2)
    '    Dim b As Long = CLng(B1) - CLng(B2)

    '    Dim distance As Double
    '    distance = Sqrt((((512 + rmean) * r * r) >> 8) + 4 * g * g + (((767 - rmean) * b * b) >> 8))
    '    'distance = Sqrt(r ^ 2 + g ^ 2 + b ^ 2)

    '    'Debug.Print("R1:" & R1.ToString("000") & vbTab & ", R2:" & R2.ToString("000") & vbTab & "G1:" & G1.ToString("000") & vbTab & ", G2:" & G2.ToString("000") & vbTab & "B1:" & B1.ToString("000") & vbTab & ", B2:" & B2.ToString("000") & vbTab & ", distance:" & distance)

    '    Return (distance)
    'End Function

End Class
