﻿Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Drawing.Graphics
Imports System.Runtime.InteropServices

Public Class cls_StripStream

    Const TAPfile_headersize As Integer = 19

    'Based upon the following analysis of the captain Rob comic I used for an example, the usage of bitpars is as follows 00=40%, 01=14%, 10=16%, 11=28%
    'So for the fastest and shortest possible file, we must assign 00 the higest frequency follwed by 11 and 10 and 01

    Const PULSE_00 As Byte = &H18
    Const PULSE_11 As Byte = &H2E
    Const PULSE_10 As Byte = &H49
    Const PULSE_01 As Byte = &H6A

    '    Const PULSE_11 As Byte = &H18
    '    Const PULSE_10 As Byte = &H2E
    '    Const PULSE_01 As Byte = &H49
    '    Const PULSE_00 As Byte = &H6A
    Const PULSE_SYNC As Byte = &H93
    Const PULSE_3000HZ As Byte = &H29

    Const PULSE_2864HZ As Byte = 43
    Const PULSE_3003HZ As Byte = 41
    Const PULSE_3157HZ As Byte = 39
    Const PULSE_3328HZ As Byte = 37
    Const PULSE_3421HZ As Byte = 36

    Const PULSE_TESTFREQ = PULSE_3000HZ

    Const PULSE_TIMEOUT As Byte = &HFF

    Const TAP_factor As Double = 8 / 985248 'factor for calculating the time a tap pulse represents in seconds
    Const TAP_cyclefactor As Double = 1 / 985248 'factor for calculating the time a tap pulse represents in seconds

    Dim byte_buf(4) As Byte

    '====================================================================================================
    '                 !!! do not change these values, otherwise data will be missed !!!
    '----------------------------------------------------------------------------------------------------
    Const SACRIFICIAL_SYNC_CNT As Integer = 6   'extra syncpulses to be send AFTER each line of image data (to allow the C64 to have a bit more time to process the image data these are sync intended to be missed/ignored/wasted)
    Const SHORT_SYNC_CNT As Integer = 3         'the absolute minimum sync period
    '====================================================================================================

    Const SYNC_BUF_SIZE As Integer = SHORT_SYNC_CNT + 4 '.. places for the sync pulses and 4 places for the packet-ID

    Const TAPESPEEDRESTORETIME As Integer = 500 'the time it takes for a stopped motor to achieve a constant speed (time in ms) or as referred to in the manual "safespacë to allow the tape to stop and start"
    Const TAPESPEEDRESTOREPULSES As Integer = TAPESPEEDRESTORETIME / (PULSE_SYNC * TAP_factor * 1000) '

    Dim sync_buf(SYNC_BUF_SIZE) As Byte

    Dim stat_datasize As Long
    Dim stat_imagedatasize As Long
    Dim stat_textdatasize As Long
    Dim stat_syncsize As Long

    'Dim huffman_00_cnt As Long
    'Dim huffman_01_cnt As Long
    'Dim huffman_10_cnt As Long
    'Dim huffman_11_cnt As Long
    'Dim huffman_total As Long

    '----------------------------------------------------------------------------------------------------------


    'Private ASCII_table() As String = {"NULL", "StartOfHeading", "StartofTeXt", "EndofTeXt", "EndOfTransmission", "ENQuery", "ACKnowledge", "BELL", "Backspace", "HorTab", "LineFeed(\n)", "VerticalTab", "FormFeed", "CarriageReturn(\r)", "ShiftOut", "ShiftIn", "DataLinkEscape", "DeviceControl-1", "DeviceControl-2", "DeviceControl-3", "DeviceControl-4", "NegativeAcKnowledge", "SYNchronousidle", "EndofTransBlock", "CANcel", "EndofMedium", "SUBstite", "ESCape", "FileSeparator", "GroupSeparator", "RecordSeparator", "UnitSeparator",
    '                                   "Space", "!", "double bracket", "#", "$", "%", "&", "single bracket", "(", ")", "*", "+", ",", "-", ".", "/", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", ";", "<", "=", ">", "?",
    '                                   "@", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "[", "\", "]", "^", "_",
    '                                   "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "{", "|", "}", "~", "DEL",
    '                                   " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ",
    '                                   " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ",
    '                                   " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ",
    '                                   " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " "}

    'the conversion table below has the control characters replaced by the filled square (0x255)
    Public ASCII_table() As String = {"■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■", "■",
                                       " ", "!", " ", "#", "$", "%", "&", "'", "(", ")", "*", "+", ",", "-", ".", "/", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", ";", "<", "=", ">", "?",
                                       "@", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "[", "\", "]", "^", "_",
                                       "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "{", "|", "}", "~", "■",
                                       "Ç", "ü", "é", "â", "ä", "à", "å", "ç", "ê", "ë", "è", "ï", "î", "ì", "Ä", "Å", "É", "æ", "Æ", "ô", "ö", "ò", "û", "ù", "ÿ", "Ö", "Ü", "ø", "£", "Ø", "×", "ƒ",
                                       "á", "í", "ó", "ú", "ñ", "Ñ", "ª", "º", "¿", "®", "¬", "½", "¼", "¡", "«", "»", "░", "▒", "▓", "│", "┤", "Á", "Â", "À", "©", "╣", "║", "╗", "╝", "¢", "¥", "┐",
                                       "└", "┴", "┬", "├", "─", "┼", "ã", "Ã", "╚", "╔", "╩", "╦", "╠", "═", "╬", "¤", "ð", "Ð", "Ê", "Ë", "È", "ı", "Í", "Î", "Ï", "┘", "┌", "█", "▄", "¦", "Ì", "▀",
                                       "Ó", "ß", "Ô", "Ò", "õ", "Õ", "µ", "þ", "Þ", "Ú", "Û", "Ù", "ý", "Ý", "¯", "´", "■", "±", "‗", "¾", "¶", "§", "÷", "¸", "°", "¨", "·", "¹", "³", "²", "■", "■"}

    'the conversion table below is lined out to the ACSII value (see table directly above), meaning that this table is suited to convert ASCII to PETSCII screencodes
    Public A2P_table() As String = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                       32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
                                       0, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 27, 47, 29, 30, 31,
                                       39, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 40, 66, 41, 0, 0}


    '----------------------------------------------------------------------------------------------------------

    Public Sub Statistics_clear()
        stat_datasize = 0
        stat_syncsize = 0
        stat_imagedatasize = 0
        stat_textdatasize = 0

        'huffman_00_cnt = 0
        'huffman_01_cnt = 0
        'huffman_10_cnt = 0
        'huffman_11_cnt = 0
    End Sub

    'return statistical datasize value in bytes (this is data)
    Public Function Statistics_datasize() As Long
        Return (stat_datasize)
    End Function

    'return statistical datasize value in bytes (this is data)
    Public Function Statistics_imagedatasize() As Long
        Return (stat_imagedatasize)
    End Function

    'return statistical datasize value in bytes (this is data)
    Public Function Statistics_textdatasize() As Long
        Return (stat_textdatasize)
    End Function

    'return statistical syncsize value in seconds (this is lost tape time)
    Public Function Statistics_syncsize() As Double
        Dim result As Double
        result = stat_syncsize * PULSE_SYNC * TAP_factor    'the number of sync pulses multiplied with the duration of a sync pulse
        Return (result)
    End Function

    'return the usages of frequencies in percentage
    'huffman was the person who realized that the most used code, should have the shortest possible signal
    'now we don't do any fancy huffman coding with constantly switching signal definitions, but we can analyze
    'the generate datasette te determine what's the best choice in general and use that. Meaning that this subroutine
    'is for development purposes only.
    'Public Sub Statistics_huffman()
    '    huffman_total = (huffman_00_cnt + huffman_01_cnt + huffman_10_cnt + huffman_11_cnt) / 100
    '    Debug.Print("00=" & Conversion.Int(huffman_00_cnt / huffman_total) & "%, 01=" & Conversion.Int(huffman_01_cnt / huffman_total) & "%, 10=" & Conversion.Int(huffman_10_cnt / huffman_total) & "%, 11=" & Conversion.Int(huffman_11_cnt / huffman_total) & "%")
    'End Sub


    'create the header of the TAP file
    Public Sub header(ByVal filename As String)
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Create)        'create or overwrite file

        'save file header information
        '----------------------------
        wFile.WriteByte(&H43)      ' 0 : C
        wFile.WriteByte(&H36)      ' 1 : 6
        wFile.WriteByte(&H34)      ' 2 : 4
        wFile.WriteByte(&H2D)      ' 3 : -
        wFile.WriteByte(&H54)      ' 4 : T
        wFile.WriteByte(&H41)      ' 5 : A
        wFile.WriteByte(&H50)      ' 6 : P
        wFile.WriteByte(&H45)      ' 7 : E
        wFile.WriteByte(&H2D)      ' 8 : -
        wFile.WriteByte(&H52)      ' 9 : R
        wFile.WriteByte(&H41)      '10 : A
        wFile.WriteByte(&H57)      '11 : W
        'wFile.WriteByte(&H0)      '12 : Version = 0 (there is no need for use to use very long pulses, so keep it simple and create a first generation file)
        wFile.WriteByte(&H1)       '12 : Version = 1 (the 5 second silence of the optinal safe zone, demands the use of a Version1 file)
        wFile.WriteByte(&H0)       '13 : Machine = 00 (C64)
        wFile.WriteByte(&H0)       '14 : Video = Pal
        wFile.WriteByte(&H0)       '15 : Reserved
        wFile.WriteByte(&HFF)      '16 : Datablock size LSB
        wFile.WriteByte(&HFF)      '17 : Datablock size ...
        wFile.WriteByte(&HFF)      '18 : Datablock size MSB

        wFile.Close()
    End Sub

    'This routine generates the "request to continue" packet
    Public Sub AddPlayerProgram(ByVal playerfilepath As String, ByVal destinationfilepath As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(destinationfilepath, FileMode.Append)            'create new file or add data to the file if it already exits

        Dim rFile As FileStream = File.OpenRead(playerfilepath)       'this is the source file
        Dim reader As New BinaryReader(rFile)
        Dim remainingsize As Long = (reader.BaseStream.Length - TAPfile_headersize)
        Dim Data As Byte

        'read and discard file header information
        For i = 0 To (TAPfile_headersize - 1)
            Data = reader.ReadByte
        Next

        'copy data into the .TAP file
        While (remainingsize > 0)
            remainingsize = remainingsize - 1
            Data = reader.ReadByte
            wFile.WriteByte(Data)
        End While

        rFile.Close()
        wFile.Close()

        'calculate the packetsize
        Dim infoReader As FileInfo = My.Computer.FileSystem.GetFileInfo(playerfilepath)
        stat_datasize = stat_datasize + infoReader.Length
    End Sub

    'this routine will modify the header of the TAP file in order to write the correct filesize information (TAP filesize) to the 3 filesize bytes
    Public Sub UpdateFilesizeInHeader(ByVal filename As String)
        Dim infoReader As FileInfo = My.Computer.FileSystem.GetFileInfo(filename)
        Dim filesize As UInteger = infoReader.Length - TAPfile_headersize
        Dim Data As Byte

        Debug.Print(".TAP file filesize = " & filesize & " bytes")
        Debug.Print("Writing .TAP file size info to .TAP file header")

        Using fs As New FileStream(filename, FileMode.Open, FileAccess.Write, FileShare.None)
            Using writer As New BinaryWriter(fs)
                Data = filesize Mod 256     'LSB of size value
                writer.Seek(16, SeekOrigin.Begin)   'byte 16 (the LSB of the filesize in the header file)
                writer.Write(Data)

                Data = (filesize / 256) Mod 256     '.SB of size value
                writer.Write(Data)

                Data = filesize / (256 * 256)     'MSB of size value
                writer.Write(Data)
            End Using
        End Using
    End Sub

    'This routine generates the "request to continue" packet
    Public Sub RequestToContinue(ByVal filename As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'send a pause allowed message
        build_sync(&H2E)                    '$12 = allow player to pause
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1
    End Sub


    'This routine generates the "separator" packet
    'Each image is separated from the previous by a separator (series of vertical black lines) just the thing you might expect between the frames of a comic
    'This routine draws these line(s)
    Public Sub Separator(ByVal filename As String, ByVal width As Integer)
        Dim i As Integer
        Dim x As Integer

        If (width = 0) Then Exit Sub 'exit subroutine when there is nothing to do

        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'send the actual separator lines
        For x = 0 To (width - 1)
            'generate line sync + packet-ID
            build_sync(&H30)                    '$30
            For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
                wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
            Next i


            'to allow the system to process the image data, like shifting the screen, additional processing time is created by sending non-critical sync pulses
            'this allows the tape to run with signals that may be ignored
            For i = 1 To SACRIFICIAL_SYNC_CNT
                wFile.WriteByte(PULSE_SYNC)     'add the bytes to the .TAP file
            Next i

        Next x


        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1

        'calculate the syncsize
        stat_syncsize = stat_syncsize + SACRIFICIAL_SYNC_CNT
    End Sub

    'This routine generates the "credits" packet
    Public Sub Series(ByVal filename As String, ByVal series As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H10)                    '$10 indicates a meta data "series" packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i


        '--payload--
        For lp As Integer = 1 To 33
            If (series.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(series, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 33
        stat_textdatasize = stat_textdatasize + 33
    End Sub

    Public Sub Title(ByVal filename As String, ByVal title As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H12)                    '$12 indicates a meta data "title" packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        For lp As Integer = 1 To 33
            If (title.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(title, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 33
        stat_textdatasize = stat_textdatasize + 33
    End Sub

    Public Sub Author(ByVal filename As String, ByVal author As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H14)                    '$14 indicates a meta data "author" packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        For lp As Integer = 1 To 33
            If (author.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(author, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 33
        stat_textdatasize = stat_textdatasize + 33
    End Sub

    Public Sub Illustrator(ByVal filename As String, ByVal illustator As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H16)                    '$16 indicates a meta data "illustrator" packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        For lp As Integer = 1 To 33
            If (illustator.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(illustator, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 33
        stat_textdatasize = stat_textdatasize + 33
    End Sub

    Public Sub BuildInfo(ByVal filename As String, ByVal buildby As String, ByVal builddate As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H18)                    '$18 indicates a meta data "build data and build by" packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        For lp As Integer = 1 To 10
            If (builddate.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(builddate, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        For lp As Integer = 1 To 19
            If (buildby.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(buildby, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        wFile.Close()
        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 10 + 19
        stat_textdatasize = stat_textdatasize + 10 + 19
    End Sub


    'This routine send the progressbar related packet
    'This packet has info about the current frame count, remaining frame count and the progressbar itself
    Public Sub ProgessBar(ByVal filename As String, ByVal framecount As ULong, ByVal remaincount As ULong)
        Const charsetoffset_7seg_0 = 112    'the offset between the value '0' and the character '0' in the C64 charset table
        Const charsetoffset_barchar = 95    'the offset to the first char of the 8-pixel wide progressbar indicator

        Dim barcalc As Double
        Dim barpos As Double
        Dim barchar As Double
        Dim totalframes As Double
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H20)                    '$20 indicates a progressbar packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        '--payload--
        'A 6 digit frame counter is more than enough to show each and every individual frame of a 3 hour movie.
        'But we won't be showing movie frames, this is intended for comic books, so 4 digits is more than enough!
        'the information is send a vale that point to the appropriate character in the character table, so that
        'printing this does not require special processing by the C64, simply print the char directly to screen
        build_byte(((framecount \ 1000) Mod 10) + charsetoffset_7seg_0)   'get the number of 1000's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        build_byte(((framecount \ 100) Mod 10) + charsetoffset_7seg_0)   'get the number of 100's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        build_byte(((framecount \ 10) Mod 10) + charsetoffset_7seg_0)   'get the number of 10's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        build_byte((framecount Mod 10) + charsetoffset_7seg_0)   'get the number of 1's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        '---------------------------

        build_byte(((remaincount \ 1000) Mod 10) + charsetoffset_7seg_0)   'get the number of 1000's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        build_byte(((remaincount \ 100) Mod 10) + charsetoffset_7seg_0)   'get the number of 100's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        build_byte(((remaincount \ 10) Mod 10) + charsetoffset_7seg_0)   'get the number of 10's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        build_byte((remaincount Mod 10) + charsetoffset_7seg_0)   'get the number of 1's
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        'calculate the position of the char on the progress bar
        totalframes = remaincount + framecount
        barcalc = (framecount / totalframes) * ((38 * 8) - 1)
        'The bar consists of 38 characters of 8 pixels each
        '-1 because of the final position, we want the progressbar on the final frame to be exactly on the last pixel of the bar
        barchar = Convert.ToInt32(barcalc) Mod 8    'convert double value to integer to prevent rounding issues
        barpos = barcalc \ 8
        If (barpos < 0) Then barpos = 0 'clamp to min. value
        If (barpos > 37) Then barpos = 37 'clamp to max. value
        If (remaincount = framecount) Then barpos = 37 'clamp to max. value on the last frame (rounding errors might prevent us from reaching this value otherwise)

        build_byte(Convert.ToByte(barpos))   'the location of the character on the bar
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        'calculate the required char (we have a choice of 8, since we want to indicate in steps of 1 per char pos, allowing us to utilize the bar with a resulation of 38*8=304 steps)
        If (barchar < 0) Then barchar = 0 'clamp to min. value
        If (barchar > 7) Then barchar = 7 'clamp to max. value                        
        build_byte(Convert.ToByte(barchar) + charsetoffset_barchar)   'the character to be printed on the bar
        wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
        wFile.WriteByte(byte_buf(2))
        wFile.WriteByte(byte_buf(1))
        wFile.WriteByte(byte_buf(0))

        'Debug.Print("framecount=" & framecount & ", remaincount=" & remaincount & ", pos=" & (Convert.ToByte(barpos)) & ", print=" & Convert.ToByte(barchar))

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 4 + 4 + 1 + 1
    End Sub

    'this routine processes the subtitle data and sends 80 chars of data or a indicator to signify that there is no data
    Public Sub Subtitles(ByVal filename As String, ByVal index As Integer, ByVal subtitle_1 As String, ByVal subtitle_2 As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        If (index = 0) Then
            build_sync(&H24)                '$24 indicates a subtitle-A packet
        Else
            build_sync(&H26)                '$26 indicates a subtitle-B packet
        End If

        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        'test if there is a payload
        If ((subtitle_1.Length = 0) And (subtitle_2.Length = 0)) Then  'test if both subtitles are empty, in that case, send the "empty subtitle" indicator
            'Debug.Print("Subtitle " & index & " is empty")

            build_byte(&HFF)                'hexadeciaml value 0xFF indicates that there are no subtitles and the the lines need to be cleared
            wFile.WriteByte(byte_buf(3))    'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
            wFile.Close()                   'close the file
            Exit Sub                        'we are done here, exit subroutine
        End If


        '--payload--
        If subtitle_1.Length < 40 Then  'add spaces to align to center
            For lp As Integer = 1 To ((40 - subtitle_1.Length) / 2)
                subtitle_1 = " " + subtitle_1
            Next lp
        End If

        For lp As Integer = 1 To 40
            If (subtitle_1.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(subtitle_1, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        If subtitle_2.Length < 40 Then      'add spaces to align to center
            For lp As Integer = 1 To ((40 - subtitle_2.Length) / 2)
                subtitle_2 = " " + subtitle_2
            Next lp
        End If

        For lp As Integer = 1 To 40
            If (subtitle_2.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(subtitle_2, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 40 + 40
        stat_textdatasize = stat_textdatasize + 40 + 40
    End Sub

    'this routine expects the source image to be like R=G=B (meaning that as long as it is allready converted into B/W, which we may asume, this routine can process it)
    Public Sub Instruction(ByVal filename As String, ByVal instruction As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H28)                    '$28 indicates an instruction field text packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i


        '--payload--
        If instruction.Length < 22 Then  'add spaces to align to center
            For lp As Integer = 1 To ((22 - instruction.Length) / 2)
                instruction = " " + instruction
            Next lp
        End If

        For lp As Integer = 1 To 22
            If (instruction.Length >= lp) Then
                build_byte(ASCII_to_PETSCII(instruction, lp))
            Else
                build_byte(&H20)         'use space if nothing needs to be printed
            End If
            wFile.WriteByte(byte_buf(3)) 'send the packet byte as a series of 4 (2-bit) pulses
            wFile.WriteByte(byte_buf(2))
            wFile.WriteByte(byte_buf(1))
            wFile.WriteByte(byte_buf(0))
        Next lp

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1 + 22
    End Sub

    'this routine expects the source image to be like R=G=B (meaning that as long as it is allready converted into B/W, which we may asume, this routine can process it)
    Public Sub Instruction_clear(ByVal filename As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&H2A)                    '$2A indicates an instruction field clear packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        wFile.Close()

        'calculate the packetsize
        stat_datasize = stat_datasize + 1
    End Sub


    'This routine sends the pixel data of the image in the forms of a series of lines
    'The idea is to send out half the image width, then send the subtitles and then send the remaining part of the image, or if there are more subtitles to be send
    'the image can be sliced up into more parts where needed, to send out the subtitles at the right time.
    'This routine expects the source image to be like R=G=B (meaning that as long as it is allready converted into B/W, which we may asume, this routine can process it
    Public Sub ImageLines(ByVal filename As String, ByVal bmp As Bitmap, ByVal x_start As Integer, ByVal x_stop As Integer)
        Dim bmpdata = bmp.LockBits(New Rectangle(0, 0, bmp.Width, bmp.Height), ImageLockMode.ReadWrite, bmp.PixelFormat)
        Dim pntr2firstpixel = bmpdata.Scan0 'first memory address obtaining a first scanning line 
        Dim rawdata(Math.Abs(bmpdata.Stride) * bmp.Height - 1) As Byte ' Declare a managed memory array, can be negative as the span so here seeking an absolute value array length 
        Marshal.Copy(pntr2firstpixel, rawdata, 0, rawdata.Length) 'copy bitmap data array to managed 
        Dim BytesPerPixel As Integer = (bmpdata.Stride / bmpdata.Width) 'the number of bytes per pixel, as this may vary depending on the input

        Dim y As Integer
        Dim x As Integer
        Dim p As Integer
        Dim q As Integer
        Dim i As Integer

        'the definition of pulses that encode the data
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        '*********************************************************************************
        'transfer the image
        'scan all pixels of the image and convert value to signal

        'Debug.Print("loop: bmp.Width=" & bmp.Width & ", bmp.Height=" & bmp.Height)
        For x = x_start To (x_stop - 1)

            'generate line sync + packet-ID
            build_sync(&H32)                    '$32 indicates a image packet
            For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
                wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
            Next i

            'process a vertical line of the bitmap
            For y = 0 To (bmp.Height - 1) Step 2
                p = (x + (y * bmp.Width)) * BytesPerPixel   'calculate pixel address
                q = p + (bmp.Width * BytesPerPixel)             'the pixel directly below that is on the next line

                If (rawdata(p) = &HFF) Then
                    If (rawdata(q) = &HFF) Then
                        wFile.WriteByte(PULSE_11)   'value 11 has been detected
                        'huffman_11_cnt = huffman_11_cnt + 1
                    Else
                        wFile.WriteByte(PULSE_10)   'value 10 has been detected
                        'huffman_10_cnt = huffman_10_cnt + 1
                    End If
                Else
                    If (rawdata(q) = &HFF) Then
                        wFile.WriteByte(PULSE_01)   'value 01 has been detected
                        'huffman_01_cnt = huffman_01_cnt + 1
                    Else
                        wFile.WriteByte(PULSE_00)   'value 00 has been detected
                        'huffman_00_cnt = huffman_00_cnt + 1
                    End If
                End If
            Next y

            stat_datasize = stat_datasize + 1 + (bmp.Height / 8)      'divide by 8, because each bit represents a pixel
            stat_imagedatasize = stat_imagedatasize + (bmp.Height / 8)

            'to allow the system to process the image data, like shifting the screen, additional processing time is created by sending non-critical sync pulses
            'this allows the tape to run with signals that may be ignored
            For i = 1 To SACRIFICIAL_SYNC_CNT
                wFile.WriteByte(PULSE_SYNC)     'add the bytes to the .TAP file
            Next i

            stat_syncsize = stat_syncsize + SACRIFICIAL_SYNC_CNT
        Next x

        bmp.UnlockBits(bmpdata) 'Unlock the bits.
        wFile.Close()
    End Sub


    'this routine makes an audio packet
    Public Sub Audio(ByVal filename As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        'generate line sync + packet-ID
        build_sync(&HE)                    '$0E indicates an audio packet
        For i = 0 To (SYNC_BUF_SIZE - 1)    'scan through the buffer to
            wFile.WriteByte(sync_buf(i))    'add the bytes to the .TAP file
        Next i

        For i = 1 To 3000
            wFile.WriteByte(PULSE_3000HZ)     'add the bytes to the .TAP file
        Next i

        wFile.WriteByte(PULSE_TIMEOUT)     'add the bytes to the .TAP file

        wFile.Close()

        'calculate the packetsize
        'stat_datasize = stat_datasize + 1 + 3000 + 1
    End Sub


    'In order to let the datasette restore it's tape speed after being paused for an undertermined time
    'And when the tape speed is unreliable, the data is unreliable, so allow some time for the tapespeed
    'to recover by sending non trivial data that does nothing but consume time.
    Public Sub RestoreTapeSpeed(ByVal filename As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        For i = 1 To TAPESPEEDRESTOREPULSES
            wFile.WriteByte(PULSE_SYNC)     'add the bytes to the .TAP file
        Next i

        wFile.Close()

        'calculate the packetsize
        'stat_datasize = stat_datasize + 1 + 4 + 4 + 1 + 1
        stat_syncsize = stat_syncsize + TAPESPEEDRESTOREPULSES
    End Sub

    'generate a continuous pulse of 3kHz
    Public Sub TestTAP_TestFreq(ByVal filename As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits

        For i = 1 To 180000
            wFile.WriteByte(PULSE_TESTFREQ)     'add the bytes to the .TAP file
        Next i

        wFile.Close()

        'calculate the packetsize
        'stat_datasize = stat_datasize + 1 + 180000
    End Sub

    'generate a frequency sweep
    Public Sub Testfreqsweep(ByVal filename As String)
        Dim i As Integer
        Dim wFile As FileStream
        wFile = New FileStream(filename, FileMode.Append)            'create new file or add data to the file if it already exits


        For sweep = PULSE_11 To PULSE_SYNC
            For i = 1 To 100
                wFile.WriteByte(sweep)     'add the bytes to the .TAP file
            Next i
        Next sweep

        wFile.Close()

        'calculate the packetsize
        'stat_datasize = stat_datasize + 1 + 180000
    End Sub

    Private Sub build_byte(ByVal value As Byte)
        For lp As Integer = 0 To 8 Step 2 'step 2 because we are processing two bits at a time

            'convert the set of two bits, into a single pulse value
            Select Case (value And 3) 'mask out the two lowest bits
                Case 0
                    byte_buf(lp / 2) = PULSE_00
                    'huffman_00_cnt = huffman_00_cnt + 1

                Case 1
                    byte_buf(lp / 2) = PULSE_01
                    'huffman_01_cnt = huffman_01_cnt + 1

                Case 2
                    byte_buf(lp / 2) = PULSE_10
                    'huffman_10_cnt = huffman_10_cnt + 1

                Case 3
                    byte_buf(lp / 2) = PULSE_11
                    'huffman_11_cnt = huffman_11_cnt + 1

            End Select

            value = value >> 2   'shift register 2 bits to the right
        Next lp
    End Sub

    'A sync is a series of pulses, followed by a packet byte
    Private Sub build_sync(ByVal packet_ID As Byte)
        Dim lp As Integer
        ''generate line sync (the duration of this pulse effectively controls the scroll rate of the screen)
        ''but if this value is TOO small, the system is not able to shift the hires screen and pulses WILL be missed

        For lp = 0 To (SYNC_BUF_SIZE - 5)   '-5 because of the SYNC_BUF_SIZE - 1 (because computer start counting from 0) and 4 extra because we need room for the packet IO
            sync_buf(lp) = PULSE_SYNC
        Next lp

        '--packet-ID--
        build_byte(packet_ID)               'the packet-ID indicates whats inside the packet
        sync_buf(SYNC_BUF_SIZE - 4) = byte_buf(3)      'MSB
        sync_buf(SYNC_BUF_SIZE - 3) = byte_buf(2)      '
        sync_buf(SYNC_BUF_SIZE - 2) = byte_buf(1)      '
        sync_buf(SYNC_BUF_SIZE - 1) = byte_buf(0)      'LSB

        stat_syncsize = stat_syncsize + (SYNC_BUF_SIZE - 4)  '-4 because we have 4 pulse positions as a reserved space in the same buffer (which will be used by the packed-ID)
    End Sub


    Private Function ASCII_to_PETSCII(ByVal textstring As String, ByVal index As Integer) As Byte
        Dim PETSCII_char As Byte
        Dim char_value As Integer

        char_value = Asc(GetChar(textstring, index))      'get ascii value of character
        If (char_value <= 128) Then
            PETSCII_char = A2P_table(char_value)
        Else
            PETSCII_char = 0
        End If

        Return (PETSCII_char)
    End Function




    '===============================================================================================================================================================

    Public Function Measure_duration(ByVal filename As String) As Double
        Dim total_time As Double = 0
        Dim data As Byte
        Dim version As Byte
        Dim machine As Byte
        Dim video As Byte
        Dim magic_word As String
        Dim cycles As Integer

        Debug.Print("File analysis")

        Try
            Dim fr As FileStream = File.OpenRead(filename)
            Dim reader As New BinaryReader(fr)
            Dim remainingsize As Long = (reader.BaseStream.Length - 19) 'the header is 19 bytes

            'read and check file header information
            magic_word = reader.ReadChars(12)
            Debug.Print("magic word = " & magic_word)
            If (magic_word <> "C64-TAPE-RAW") Then
                MsgBox("Unexpected content" & vbCrLf & "This file does ot contain the magic word")
                Return (0)
            End If

            'Version = 0 (this is the simplest version, all values are single bytes)
            version = reader.ReadByte
            If (version > 1) Then
                MsgBox("Unsupported version" & vbCrLf & "Only TAP files of version 0 and 1 are supported")
                Return (0)
            End If

            'Machine = 00 = C64
            machine = reader.ReadByte
            If (machine <> 0) Then
                MsgBox("Unsupported version" & vbCrLf & "Only TAP files for the C64 are supported")
                Return (0)
            End If

            'Video = 00 = Pal
            video = reader.ReadByte
            If (video <> 0) Then
                MsgBox("Unsupported version" & vbCrLf & "Only TAP files for PAL systems are supported")
                Return (0)
            End If

            data = reader.ReadByte 'discard the "Reserved" field
            data = reader.ReadByte 'discard the "Datablock size LSB"
            data = reader.ReadByte 'discard the "Datablock size ..."
            data = reader.ReadByte 'discard the "Datablock size MSB"

            While (remainingsize > 0)
                If (version = 0) Then
                    remainingsize = remainingsize - 1
                    data = reader.ReadByte
                    total_time = total_time + (data * TAP_factor)
                End If

                If (version = 1) Then
                    remainingsize = remainingsize - 1
                    data = reader.ReadByte
                    If (data = 0) Then
                        cycles = reader.ReadByte * 1
                        cycles = cycles + (reader.ReadByte * 256)
                        cycles = cycles + (reader.ReadByte * 65536)

                        remainingsize = remainingsize - 3
                        total_time = total_time + (cycles * TAP_cyclefactor)
                    Else
                        total_time = total_time + (data * TAP_factor)
                    End If
                End If

            End While

            fr.Close()

        Catch
            MessageBox.Show("Something went wrong")
        End Try

        Return (total_time)
    End Function


    'here we do NOT check the header, since we will only be calling this function to split a file we've just created (and know is right)
    Public Sub Split(ByVal rFilename As String, ByVal splitsize As Double)
        Const leaderduration As Double = 10     'this is the time the leader AT THE END OF THE TAPE requires to run (the leader at the beginning is the responsibillity of the person recording the tape)
        Const maxtimeperimage As Double = 10    'this is a safety margin to prevent splitting the tape in the middle of an displayable image

        Dim data_header(TAPfile_headersize) As Byte
        Dim data As Byte = 0
        Dim data_prev As Byte = 0
        Dim total_time As Double = 0   'make sure that we trigger a split in order to create the fist file
        Dim split_allowed As Boolean = False
        Dim split_count As Integer = 1
        Dim wFilename As String

        Try
            Dim wFile As FileStream                       'this is the destination file

            wFilename = Path.GetDirectoryName(rFilename) & "\" & Path.GetFileNameWithoutExtension(rFilename) & "-#1.TAP"
            Debug.Print("wFilename =" & wFilename)
            wFile = New FileStream(wFilename, FileMode.Append)            'create new file or add data to the file if it already exits (which it doesn't)

            Dim rFile As FileStream = File.OpenRead(rFilename)       'this is the source file
            Dim reader As New BinaryReader(rFile)
            Dim remainingsize As Long = (reader.BaseStream.Length - TAPfile_headersize)

            'read and check file header information
            data_header = reader.ReadBytes(TAPfile_headersize)

            'writeheader data to the beginnig of the .TAP file
            For lp = 0 To (TAPfile_headersize - 1)
                wFile.WriteByte(data_header(lp))
            Next lp

            'add remaining data and split if needed
            While (remainingsize > 0)
                remainingsize = remainingsize - 1
                data_prev = data
                data = reader.ReadByte

                'detect first SYNPULSE in a series of sync pulses
                If ((data = PULSE_SYNC) And (data <> data_prev)) Then
                    split_allowed = True
                Else
                    split_allowed = False
                End If

                total_time = total_time + (data * TAP_factor)

                'only allow to split on a the very first pulse of a SYNC signal
                If (split_allowed = True) Then
                    If (total_time > (splitsize - leaderduration - maxtimeperimage)) Then
                        Debug.Print("Splitting file")
                        total_time = 0  'new .TAP so reset time counter
                        split_count = split_count + 1

                        'create new file
                        wFilename = Path.GetDirectoryName(rFilename) & "\" & Path.GetFileNameWithoutExtension(rFilename) & "-#" & split_count.ToString & ".TAP"
                        Debug.Print("wFilename =" & wFilename)
                        wFile.Close()   'if there was something open... close it now
                        wFile = New FileStream(wFilename, FileMode.Append)            'create new file or add data to the file if it already exits (which it doesn't)

                        'writeheader data to the beginning of the .TAP file
                        For lp = 0 To (TAPfile_headersize - 1)
                            wFile.WriteByte(data_header(lp))
                        Next lp
                    End If
                End If

                wFile.WriteByte(data)    'add byte to the .TAP file

            End While

            wFile.Close()
            rFile.Close()

        Catch
            MessageBox.Show("Something went wrong")
        End Try

    End Sub


End Class

