﻿Imports System
Imports System.Xml
Imports System.IO           'used for lot's of things like "Path" and "Filestream"
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Drawing.Graphics
Imports System.Runtime.InteropServices

Public Class frm_Main
    Private SourceImage As Bitmap

    Private OutputSizeX As Integer = 160
    Private OutputSizeY As Integer = 96

    Private clsStripStream As New cls_StripStream               'class to generate the .TAP file
    Private clsImgConversion As New cls_ImageConversion     'class to do the scaling/converting/dithering

    Private pixelcolor As Color = Color.White
    Private backgroundcolor As Color = Color.Black

    Private numctrl_currentframe_disablehandler As Boolean = False

    Public Structure project_struct
        Public available As Boolean         'a simple flag to indicate the status of the project (if the project isn't available, saving should be impossible)
        Public filename As String           'the filename (complete path) of the project file
    End Structure

    Public project As project_struct
    Public frame_imagefilename() As String      'the filename of the image belonging to this frame
    Public frame_contrast() As Integer
    Public frame_brightness() As Integer
    Public frame_thresshold() As Integer
    Public frame_advance() As Integer
    Public frame_align() As Integer
    Public frame_text_A1() As String        '1 dimensional array for string data
    Public frame_text_A2() As String        '1 dimensional array for string data
    Public frame_text_B1() As String        '1 dimensional array for string data
    Public frame_text_B2() As String        '1 dimensional array for string data

    '..........................................................................................................

    Const default_series As String = "-undefined-"
    Const default_title As String = "-undefined-"
    Const default_author As String = "-undefined-"
    Const default_illustrator As String = "-undefined-"
    Const default_build_by As String = "-undefined-"
    Const default_imagefilename As String = "-undefined-"
    Const default_contrast As Integer = 100
    Const default_brightness As Integer = 0
    Const default_thresshold As Integer = 128
    Const default_advance As Integer = 0
    Const default_align As Integer = 0
    Const default_AddPlayerToOutput = False
    Const default_CompressLoaderFile = True
    Const default_UseFastloader = True
    Const default_AddSafeZone = True
    Const default_subtitle_text_1 As String = ""
    Const default_subtitle_text_2 As String = ""

    Const sst_datafoldernameend As String = "_data" 'the datafolder should be the name of the projectfile, but with _data added to it

    '..........................................................................................................

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If (project.available = True) Then 'only request to save when there is something to save
            If MessageBox.Show("Are you sure you want to exit?", "Exit program?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                My.Settings.Save()

                If MessageBox.Show("Do you want to save the project?", "Save project?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                    Save_projectsettings()
                End If
            Else
                e.Cancel = True
            End If
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Set_defaultvalues(0)
        Clear_project() 'set all project related values to default (as if nothing was loaded or created)

        EnableControls(Controls, False)     'disable all buttons, since there is nothing loaded or created yet
        MenuStrip1.Enabled = True           'make sure the toolstrip meu items are enabled, otherwise the program is useless

        TabControl1.SelectedIndex = 0   'select first tab
        TabControl2.SelectedIndex = 0   'select first tab

        Application.DoEvents()      'update the GUI!!!
    End Sub

    Public Sub EnableControls(ByVal controls As Control.ControlCollection, ByVal enable As Boolean)
        For Each c As Control In controls
            c.Enabled = enable
            EnableControls(c.Controls, enable)
        Next
    End Sub

    Private Sub Set_defaultvalues(ByVal numberofframes As Long)
        'cmb_Framecolorback.SelectedIndex = 1 'default=white

        txt_series.Text = default_series
        txt_title.Text = default_title
        txt_author.Text = default_author
        txt_illustrator.Text = default_illustrator
        txt_buildby.Text = default_build_by

        txt_subtitle_A1.Text = default_subtitle_text_1
        txt_subtitle_A2.Text = default_subtitle_text_2

        txt_subtitle_B1.Text = default_subtitle_text_1
        txt_subtitle_B2.Text = default_subtitle_text_2

        cmb_ImageAdvance.SelectedIndex = 0
        cmb_ImageAlign.SelectedIndex = 0
        cmb_Duration.SelectedIndex = 0

        chk_AddPlayerToOutput.Checked = default_AddPlayerToOutput
        chk_CompressLoaderFile.Checked = default_CompressLoaderFile
        chk_UseFastloader.Checked = default_UseFastloader
        chk_AddSafeZone.Checked = default_AddSafeZone

        txt_ImageFilename.Text = default_imagefilename

        trk_Contrast.Value = default_contrast
        trk_Brightness.Value = default_brightness
        trk_Thresshold.Value = default_thresshold

        cmb_ImageAdvance.SelectedIndex = default_advance
        cmb_ImageAlign.SelectedIndex = default_align

        If (numberofframes > 0) Then
            For lp As Long = 0 To numberofframes
                frame_imagefilename(numctrl_currentframe.Value) = default_imagefilename

                frame_contrast(numctrl_currentframe.Value) = default_contrast
                frame_brightness(numctrl_currentframe.Value) = default_brightness
                frame_thresshold(numctrl_currentframe.Value) = default_thresshold

                frame_advance(numctrl_currentframe.Value) = default_advance
                frame_align(numctrl_currentframe.Value) = default_align

                frame_text_A1(lp) = default_subtitle_text_1
                frame_text_A2(lp) = default_subtitle_text_2

                frame_text_B1(lp) = default_subtitle_text_1
                frame_text_B2(lp) = default_subtitle_text_2
            Next
        End If

    End Sub


    Private Sub btn_Prev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Prev.Click
        If (numctrl_currentframe.Value > 1) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value - 1
        End If
    End Sub

    Private Sub btn_Next_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Next.Click
        If (numctrl_currentframe.Value < numctrl_currentframe.Maximum) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value + 1
        End If
    End Sub

    Private Sub numctrl_currentframe_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numctrl_currentframe.ValueChanged
        If (numctrl_currentframe_disablehandler = True) Then
            'Debug.Print("numctrl_currentframe handler is disabled, event will be ignored")
            Exit Sub
        End If

        If (Val(txt_totalframes.Text) = 0) Then
            Debug.Print("error prevented, the is no data at index 0")
            Exit Sub
        End If

        Load_image(numctrl_currentframe.Value)    'load the image
    End Sub

    Private Function Load_image(ByVal frame_ID As Integer) As Boolean
        Dim picture_loaded As Boolean
        Dim fpath As String = txt_ProjectDataPath.Text & "\" & frame_imagefilename(frame_ID)
        Debug.Print("Loading image, frame:" & numctrl_currentframe.Value)

        'SourceImage = Image.FromFile(dataPath & "\" & lst_Batch.SelectedItem)   'this code is evil... because it keeps a lock on the file!!!
        'To prevent our program from keeping a lock on the file we must use a temporary stream to move the data, then close the stream when were done

        If My.Computer.FileSystem.FileExists(fpath) Then
            Dim fs As FileStream
            fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
            SourceImage = System.Drawing.Image.FromStream(fs)
            fs.Close()

            txt_ImageFilename.Text = Path.GetFileNameWithoutExtension(fpath)   'strip the path so only the filename remains
            picture_loaded = True
        Else
            Debug.Print("Error: " & fpath & " could not be found.")
            pic_Source.Image = pic_Source.ErrorImage
            pic_Dest.Image = pic_Source.ErrorImage
            txt_ImageFilename.Text = Path.GetFileNameWithoutExtension(fpath)   'strip the path so only the filename remains
            picture_loaded = False
        End If


        '-----------------------
        'set all the settings and fields to the values as stored in the project data arrays
        'because each frame could have custom settings for many things subtitle, contrast, etc.

        txt_subtitle_A1.Text = frame_text_A1(frame_ID)
        txt_subtitle_A2.Text = frame_text_A2(frame_ID)

        txt_subtitle_B1.Text = frame_text_B1(frame_ID)
        txt_subtitle_B2.Text = frame_text_B2(frame_ID)

        trk_Contrast.Value = frame_contrast(frame_ID)
        trk_Brightness.Value = frame_brightness(frame_ID)
        trk_Thresshold.Value = frame_thresshold(frame_ID)

        cmb_ImageAdvance.SelectedIndex = frame_advance(frame_ID)
        cmb_ImageAlign.SelectedIndex = frame_align(frame_ID)

        If (picture_loaded = True) Then
            pic_Source.Image = clsImgConversion.ChangeBrightnessContrast(SourceImage, trk_Brightness.Value, trk_Contrast.Value)
            pic_Source.Refresh()
        End If

        '-----------------------

        Overview(frame_ID)
        UpdateAll()                 'use all settings to calculate the final image
        Application.DoEvents()      'update the GUI!!! (this is mostly important for the situation where we are continuosly calling this routine, for instance in batch processing)

        Return (picture_loaded)

    End Function

    Private Sub UpdateAll()
        Dim scalefactor As Double
        Dim scale_x As Integer
        Dim scale_y As Integer

        If Not (pic_Source.Image Is Nothing) Then
            Dim bmp As New Bitmap(pic_Source.Image)      'use the image as stored in the picturebox

            'calculate scalefactor, but maintain the height of the image, because the length could be infinitely large if it nees to be, we've got all the room, due to the scrolling effect
            scalefactor = bmp.Width / bmp.Height
            scale_y = OutputSizeY
            scale_x = scale_y * scalefactor

            'Debug.Print("scale_x = " & scale_x & ", scale_y = " & scale_y)
            pic_Dest.Image = clsImgConversion.ToBW_Burkes(clsImgConversion.ResizeHighQualityTo(bmp, scale_x, scale_y), 0, trk_Thresshold.Value)
            If (Panel_preview.Width < pic_Dest.Width) Then
                pic_Dest.Left = 3
            Else
                pic_Dest.Left = (Panel_preview.Width - pic_Dest.Width) / 2
            End If

            pic_Dest.Refresh()
        End If
    End Sub

    'this routine fills 8 picture boxes with the images around the current frame, this to give the user a bit of an overview
    Private Sub Overview(ByVal frame_ID As Integer)
        Dim fs As FileStream
        Dim fpath As String

        'The quick and easy way (THIS CODE IS EVIL as it loack the file!!!)
        '------------------------------------------------------------------
        'pic_overview_n3.Image = Bitmap.FromFile(fpath)         


        'The proper way (this code doesn't lock the file and allows the user to manipulate the imagefile in another program and to press refresh when done)
        '--------------------------------------------------------------------------------------------------------------------------------------------------
        'fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
        'pic_overview_n3.Image = System.Drawing.Image.FromStream(fs)
        'fs.Close()


        pic_overview_n3.Image = pic_overview_n3.ErrorImage
        If (frame_ID - 3 > 0) Then
            lbl_overview_n3.Text = frame_ID - 3
            fpath = txt_ProjectDataPath.Text & "\" & frame_imagefilename(frame_ID - 3)
            If My.Computer.FileSystem.FileExists(fpath) Then
                fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
                pic_overview_n3.Image = System.Drawing.Image.FromStream(fs)
                fs.Close()                
            End If
        Else
            lbl_overview_n3.Text = ""
        End If

        pic_overview_n2.Image = pic_overview_n2.ErrorImage
        If (frame_ID - 2 > 0) Then
            lbl_overview_n2.Text = frame_ID - 2
            fpath = txt_ProjectDataPath.Text & "\" & frame_imagefilename(frame_ID - 2)
            If My.Computer.FileSystem.FileExists(fpath) Then
                fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
                pic_overview_n2.Image = System.Drawing.Image.FromStream(fs)
                fs.Close()
            End If
        Else
            lbl_overview_n2.Text = ""
        End If

        pic_overview_n1.Image = pic_overview_n1.ErrorImage
        If (frame_ID - 1 > 0) Then
            lbl_overview_n1.Text = frame_ID - 1
            fpath = txt_ProjectDataPath.Text & "\" & frame_imagefilename(frame_ID - 1)
            If My.Computer.FileSystem.FileExists(fpath) Then
                fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
                pic_overview_n1.Image = System.Drawing.Image.FromStream(fs)
                fs.Close()
            End If
        Else
            lbl_overview_n1.Text = ""
        End If


        pic_overview_1.Image = pic_overview_1.ErrorImage
        If (frame_ID + 1 <= Val(txt_totalframes.Text)) Then
            lbl_overview_1.Text = frame_ID + 1
            fpath = txt_ProjectDataPath.Text & "\" & frame_imagefilename(frame_ID + 1)
            If My.Computer.FileSystem.FileExists(fpath) Then
                fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
                pic_overview_1.Image = System.Drawing.Image.FromStream(fs)
                fs.Close()
            End If
        Else
            lbl_overview_1.Text = ""
        End If

        pic_overview_2.Image = pic_overview_2.ErrorImage
        If (frame_ID + 2 <= Val(txt_totalframes.Text)) Then
            lbl_overview_2.Text = frame_ID + 2
            fpath = txt_ProjectDataPath.Text & "\" & frame_imagefilename(frame_ID + 2)
            If My.Computer.FileSystem.FileExists(fpath) Then
                fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
                pic_overview_2.Image = System.Drawing.Image.FromStream(fs)
                fs.Close()
            End If
        Else
            lbl_overview_2.Text = ""
        End If

        pic_overview_3.Image = pic_overview_3.ErrorImage
        If (frame_ID + 3 <= Val(txt_totalframes.Text)) Then
            lbl_overview_3.Text = frame_ID + 3
            fpath = txt_ProjectDataPath.Text & "\" & frame_imagefilename(frame_ID + 3)
            If My.Computer.FileSystem.FileExists(fpath) Then
                fs = New FileStream(fpath, IO.FileMode.Open, IO.FileAccess.Read)
                pic_overview_3.Image = System.Drawing.Image.FromStream(fs)
                fs.Close()
            End If
        Else
            lbl_overview_3.Text = ""
        End If
    End Sub

    Private Sub pic_overview_n3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pic_overview_n3.Click
        If (numctrl_currentframe.Value - 3 > 0) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value - 3
        End If
    End Sub

    Private Sub pic_overview_n2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pic_overview_n2.Click
        If (numctrl_currentframe.Value - 2 > 0) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value - 2
        End If
    End Sub

    Private Sub pic_overview_n1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pic_overview_n1.Click
        If (numctrl_currentframe.Value - 1 > 0) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value - 1
        End If
    End Sub

    Private Sub pic_overview_1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pic_overview_1.Click
        If (numctrl_currentframe.Value + 1 <= Val(txt_totalframes.Text)) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value + 1
        End If
    End Sub

    Private Sub pic_overview_2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pic_overview_2.Click
        If (numctrl_currentframe.Value + 2 <= Val(txt_totalframes.Text)) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value + 2
        End If
    End Sub

    Private Sub pic_overview_3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pic_overview_3.Click
        If (numctrl_currentframe.Value + 3 <= Val(txt_totalframes.Text)) Then
            numctrl_currentframe.Value = numctrl_currentframe.Value + 3
        End If
    End Sub

    Private Sub UpdateProjectSettings()
        If (project.available = True) Then
            UpdateAll()
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstrip_Exit.Click
        Me.Close()
    End Sub

    Private Sub ExportCurrentImageToHiresBinaryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportCurrentImageToHiresBinaryToolStripMenuItem.Click
        SaveFileDialog.Title = "Save current hires image data"
        SaveFileDialog.FileName = "hires_data.bin"
        SaveFileDialog.ValidateNames = False
        SaveFileDialog.Filter = "Data files (*.BIN)|*.BIN|All files (*.*)|*.*"
        If (SaveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            SaveHiresImage(pic_Dest.Image, SaveFileDialog.FileName)
        End If
    End Sub


    Private Sub SaveHiresImage(ByVal bmp As Bitmap, ByVal Filename As String)
        Dim wFile As FileStream
        Dim Data As Byte
        Dim pxf As PixelFormat = PixelFormat.Format24bppRgb                             'Specify a pixel format.
        Dim rect As Rectangle = New Rectangle(0, 0, bmp.Width, bmp.Height)              'Lock the bitmap's bits.
        Dim bmpData As BitmapData = bmp.LockBits(rect, ImageLockMode.ReadWrite, pxf)
        Dim ptr As IntPtr = bmpData.Scan0                                               'Get the address of the first line of the bitmap.
        Dim numBytes As Integer = bmp.Width * bmp.Height * 3                            'Declare an array to hold the bytes of the bitmap.
        Dim rgbValues(numBytes) As Byte
        Dim Lum_array(numBytes / 3) As Byte   'luminance array is 3 times smaller as the RGB array
        Dim p As Long

        Marshal.Copy(ptr, rgbValues, 0, numBytes)                                       'Copy the RGB values into the array.

        'convert the RGB array to a luminance array
        For i As Integer = 0 To Lum_array.Length - 1
            Lum_array(i) = rgbValues(i * 3)   'the image we use has R=G=B (as long as it is already converted into B/W, which we may asume)
        Next

        Debug.Print("Building data file to disk path: " & Filename)
        wFile = New FileStream(Filename, FileMode.Create)            'open the file to which we want to write

        For y As Integer = 0 To ((bmp.Height - 7) - 1) Step 8
            For x As Integer = 0 To (bmp.Width - 1) Step 8
                For kar = 0 To 7
                    Data = 0  'clear the value
                    For b As Integer = 0 To 7
                        Data = Data * 2 'shift left
                        p = x + (y * bmp.Width) + (kar * bmp.Width) + b
                        If (Lum_array(p) = &HFF) Then
                            Data = Data + 1
                        End If
                        'Debug.Print("Sprite_row=" & sprite_row & " Sprite_col=" & sprite_col & " Sprite_y=" & sprite_y & " Sprite_x=" & sprite_x & " b=" & b)
                    Next b
                    wFile.WriteByte(Data)
                Next kar
            Next x
        Next y

        wFile.Close()
        bmp.UnlockBits(bmpData)                                                         'Unlock the bits.
    End Sub

    '=============================================================================================================

    'reset default values (as if nothing was loaded or created)
    Private Sub Clear_project()
        project.available = False
        txt_ProjectDataPath.Text = ""
        txt_PlayerFilename.Text = ""
        txt_totalframes.Text = 0
        numctrl_currentframe.Value = 0
        Redim_ProjectArrays(0)
    End Sub

    Private Sub Redim_ProjectArrays(ByVal array_size As Integer)
        're-dimension the arrays, but leave the contents intact is possible (preserve)
        ReDim Preserve frame_text_A1(array_size)
        ReDim Preserve frame_text_A2(array_size)
        ReDim Preserve frame_text_B1(array_size)
        ReDim Preserve frame_text_B2(array_size)
        ReDim Preserve frame_imagefilename(array_size)
        ReDim Preserve frame_contrast(array_size)
        ReDim Preserve frame_brightness(array_size)
        ReDim Preserve frame_thresshold(array_size)
        ReDim Preserve frame_advance(array_size)
        ReDim Preserve frame_align(array_size)
    End Sub

    Private Sub toolstrip_NewProject_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstrip_NewProject.Click
        Dim new_project_filename As String      'the name of the project file holding all the project related settings, links to image data, subtitles, etc.
        Dim new_project_datafolder As String    'the datafolder holds all the images the project uses (by having all the images in a single folder, a complete project can be moved easily to new location if that should ever be needed or desired by the user)

        SaveFileDialog.Title = "Select name and location of the projectfile"
        SaveFileDialog.FileName = "new_sst_project.SST"
        SaveFileDialog.ValidateNames = False
        SaveFileDialog.Filter = "StripStream project files (*.SST)|*.SST|All files (*.*)|*.*"   'SST = StripSTream project
        If (SaveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            'Debug.Print("SaveFileDialog.FileName" & SaveFileDialog.FileName)
            If File.Exists(SaveFileDialog.FileName) Then             'check if file already exist
                MsgBox("An error has occured, a file of the same name already exist in this location.")
                Exit Sub
            End If

            new_project_filename = Path.GetFileNameWithoutExtension(SaveFileDialog.FileName) & sst_datafoldernameend
            new_project_datafolder = Path.GetDirectoryName(SaveFileDialog.FileName) & "\" & new_project_filename
            Debug.Print("datafoldername = " & new_project_datafolder)

            If Not Directory.Exists(new_project_datafolder) Then
                Directory.CreateDirectory(new_project_datafolder)
            Else
                MsgBox("Please select a different location, this folder already contains a stripstream project.")
                Exit Sub
            End If

            txt_ProjectDataPath.Text = new_project_datafolder
            project.filename = SaveFileDialog.FileName
            project.available = True

            EnableControls(Controls, True)      'enable the user interface
            txt_ProjectDataPath.Enabled = False 'this should never be enabled (it just an indicator)
            txt_totalframes.Enabled = False     'this should never be enabled (it just an indicator)
            txt_ImageFilename.Enabled = False   'this should never be enabled (it just an indicator)
            txt_PlayerFilename.Enabled = False  'this should never be enabled (it just an indicator)

            Addframe()  'create the first frame in the project
            Save_projectsettings()  'save the project
        End If
    End Sub

    '=============================================================================================================

    Private Sub toolstrip_SaveProject_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstrip_SaveProject.Click
        If (project.available = False) Then
            MsgBox("Sorry, there is nothing to save...")
            Exit Sub
        End If

        Save_projectsettings()
    End Sub

    Private Sub toolstrip_SaveProjectAs_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstrip_SaveProjectAs.Click
        Dim SourcePath As String = txt_ProjectDataPath.Text
        Dim DestinationPath As String = ""

        If (project.available = False) Then
            MsgBox("Sorry, there is nothing to save...")
            Exit Sub
        End If

        SaveFileDialog.Title = "Save projectfile and data under a new name"
        SaveFileDialog.FileName = "newfilename.SST"
        SaveFileDialog.ValidateNames = False
        SaveFileDialog.Filter = "StripStream project files (*.SST)|*.SST|All files (*.*)|*.*"   'SST = StripSTream project
        SaveFileDialog.OverwritePrompt = False   'do not ask for overwrite confirmation
        If (SaveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            'creating a project file under a new name is useless without copying the datafolder too
            SourcePath = txt_ProjectDataPath.Text
            DestinationPath = Path.GetDirectoryName(SaveFileDialog.FileName) & "\" & Path.GetFileNameWithoutExtension(SaveFileDialog.FileName) & sst_datafoldernameend
            txt_ProjectDataPath.Text = DestinationPath

            If (Not Directory.Exists(DestinationPath)) And (Not File.Exists(SaveFileDialog.FileName)) Then
                Directory.CreateDirectory(DestinationPath)
            Else
                MsgBox("Please select a different name or location. The selected path already contains a stripstream project of a similar name. Overwriting projectfile data is not allowed, if desired, remove or rename the folder manually.")
                txt_ProjectDataPath.Text = SourcePath 'undo projectpath change
                Exit Sub
            End If

            Cursor = Cursors.WaitCursor 'notify user we're doing something
            Microsoft.VisualBasic.FileIO.FileSystem.CopyDirectory(SourcePath, DestinationPath)  'copy datafolder to new name and location
            project.filename = SaveFileDialog.FileName                                          'add the new location information in the project file
            Save_projectsettings()                                                              'save the projectfile
            Cursor = Cursors.Default    'return cursor back to normal

        Else
            MsgBox("The ""Save as"" action, has been aborted.")
        End If
    End Sub

    Private Sub Save_projectsettings()
        If (project.available = False) Then
            'MsgBox("Sorry, there is nothing to save...")
            Exit Sub
        End If

        Dim settings As New XmlWriterSettings()
        settings.Indent = True
        Dim XmlWrt As XmlWriter = XmlWriter.Create(project.filename, settings)
        With XmlWrt
            .WriteStartDocument()           ' Write the Xml declaration.

            .WriteComment("This file contains the settings for a 'comic-stream' project")  ' Write a comment.

            .WriteStartElement("Project")      ' Write the root element.

            '----------------------------

            .WriteStartElement("Info")

            .WriteStartElement("Datapath")
            .WriteString(txt_ProjectDataPath.text)
            .WriteEndElement()

            .WriteStartElement("Series")
            .WriteString(txt_series.Text)
            .WriteEndElement()

            .WriteStartElement("Title")
            .WriteString(txt_title.Text)
            .WriteEndElement()

            .WriteStartElement("Author")
            .WriteString(txt_author.Text)
            .WriteEndElement()

            .WriteStartElement("Illustrator")
            .WriteString(txt_illustrator.Text)
            .WriteEndElement()

            .WriteStartElement("Buildby")
            .WriteString(txt_buildby.Text)
            .WriteEndElement()

            .WriteStartElement("Playerfilename")
            .WriteString(txt_PlayerFilename.Text)
            .WriteEndElement()

            .WriteStartElement("Max_duration")
            .WriteString(cmb_Duration.SelectedIndex.ToString)
            .WriteEndElement()

            .WriteStartElement("PlayerEnable")
            .WriteString(chk_AddPlayerToOutput.Checked.ToString)
            .WriteEndElement()

            .WriteStartElement("CompressEnable")
            .WriteString(chk_CompressLoaderFile.Checked.ToString)
            .WriteEndElement()

            .WriteStartElement("FastloaderEnable")
            .WriteString(chk_UseFastloader.Checked.ToString)
            .WriteEndElement()

            .WriteStartElement("SafeZoneEnable")
            .WriteString(chk_AddSafeZone.Checked.ToString)
            .WriteEndElement()

            .WriteStartElement("Frames")
            .WriteString(txt_totalframes.Text)
            .WriteEndElement()

            .WriteEndElement()

            '----------------------------

            For lp As Long = 1 To Val(txt_totalframes.Text) 'we start with frame 1 and stop at the last frame
                .WriteStartElement("Frame")

                .WriteStartElement("ID")
                .WriteString(lp.ToString)
                .WriteEndElement()

                .WriteStartElement("Image")
                .WriteString(frame_imagefilename(lp).ToString)
                .WriteEndElement()

                .WriteStartElement("Contrast")
                .WriteString(frame_contrast(lp).ToString)
                .WriteEndElement()

                .WriteStartElement("Brightness")
                .WriteString(frame_brightness(lp).ToString)
                .WriteEndElement()

                .WriteStartElement("Thresshold")
                .WriteString(frame_thresshold(lp).ToString)
                .WriteEndElement()

                .WriteStartElement("Advance")
                .WriteString(frame_advance(lp).ToString)
                .WriteEndElement()

                .WriteStartElement("Align")
                .WriteString(frame_align(lp).ToString)
                .WriteEndElement()

                .WriteStartElement("Subtitle_A1")
                .WriteString(frame_text_A1(lp))
                .WriteEndElement()

                .WriteStartElement("Subtitle_A2")
                .WriteString(frame_text_A2(lp))
                .WriteEndElement()

                .WriteStartElement("Subtitle_B1")
                .WriteString(frame_text_B1(lp))
                .WriteEndElement()

                .WriteStartElement("Subtitle_B2")
                .WriteString(frame_text_B2(lp))
                .WriteEndElement()

                .WriteEndElement()
            Next

            '----------------

            .WriteEndDocument()             ' Close the XmlTextWriter.
            .Close()
        End With
        Debug.Print("Project has been saved to " & project.filename)
        'MsgBox("Project data saved")

    End Sub

    Private Sub toolstrip_LoadProject_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstrip_LoadProject.Click
        Dim ID_value As Long = 0
        Dim error_encountered = False

        OpenFileDialog.Title = "Select StripStream project to be opened"
        OpenFileDialog.Filter = "StripStream project files (*.SST)|*.*SST"
        'OpenFileDialog.InitialDirectory = ""
        OpenFileDialog.FileName = ""
        If (OpenFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then

            project.available = False    'set flag to flase untill we are completely finished loading all project related values
            project.filename = OpenFileDialog.FileName

            'create a new xmltextreader object. This is the object that we will loop and will be used to read the xml file
            Dim XML As XmlReader = New XmlTextReader(OpenFileDialog.FileName)

            'loop through the xml file
            While (XML.Read() And (error_encountered = False))
                Dim type = XML.NodeType

                'if node type was element
                If (type = XmlNodeType.Element) Then

                    'project variables
                    If (XML.Name = "Datapath") Then txt_ProjectDataPath.Text = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Series") Then txt_series.Text = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Title") Then txt_title.Text = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Author") Then txt_author.Text = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Illustrator") Then txt_illustrator.Text = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Buildby") Then txt_buildby.Text = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Playerfilename") Then txt_PlayerFilename.Text = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Max_duration") Then
                        cmb_Duration.SelectedIndex = Val(XML.ReadInnerXml.ToString())
                    End If

                    If (XML.Name = "PlayerEnable") Then
                        If (XML.ReadInnerXml.ToString() = "True") Then
                            chk_AddPlayerToOutput.Checked = True
                        Else
                            chk_AddPlayerToOutput.Checked = False
                        End If
                    End If

                    If (XML.Name = "CompressEnable") Then
                        If (XML.ReadInnerXml.ToString() = "True") Then
                            chk_CompressLoaderFile.Checked = True
                        Else
                            chk_CompressLoaderFile.Checked = False
                        End If
                    End If

                    If (XML.Name = "FastloaderEnable") Then
                        If (XML.ReadInnerXml.ToString() = True) Then
                            chk_UseFastloader.Checked = True
                        Else
                            chk_UseFastloader.Checked = False
                        End If
                    End If

                    If (XML.Name = "SafeZoneEnable") Then
                        If (XML.ReadInnerXml.ToString() = True) Then
                            chk_AddSafeZone.Checked = True
                        Else
                            chk_AddSafeZone.Checked = False
                        End If
                    End If

                    If (XML.Name = "Frames") Then
                        txt_totalframes.Text = XML.ReadInnerXml.ToString()
                        Redim_ProjectArrays(Val(txt_totalframes.Text))          'create an array that fits the amount of data we might require for this project
                    End If

                    '-----------------------------------------------

                    'frame related variables
                    If (XML.Name = "ID") Then
                        ID_value = Val(XML.ReadInnerXml.ToString())

                        If (ID_value > Val(txt_totalframes.Text)) Then
                            error_encountered = True
                            MsgBox("A frame with an ID (" & ID_value & ") greater than the total number of frames (" & txt_totalframes.Text & ") was found, import is aborted." & vbCrLf & "Please check file consistency.")
                        End If
                    End If

                    If (XML.Name = "Image") Then frame_imagefilename(ID_value) = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Contrast") Then frame_contrast(ID_value) = Val(XML.ReadInnerXml.ToString())
                    If (XML.Name = "Brightness") Then frame_brightness(ID_value) = Val(XML.ReadInnerXml.ToString())
                    If (XML.Name = "Thresshold") Then frame_thresshold(ID_value) = Val(XML.ReadInnerXml.ToString())
                    If (XML.Name = "Advance") Then frame_advance(ID_value) = Val(XML.ReadInnerXml.ToString())
                    If (XML.Name = "Align") Then frame_align(ID_value) = Val(XML.ReadInnerXml.ToString())

                    If (XML.Name = "Subtitle_A1") Then frame_text_A1(ID_value) = XML.ReadInnerXml.ToString()
                    If (XML.Name = "Subtitle_A2") Then frame_text_A2(ID_value) = XML.ReadInnerXml.ToString()

                    If (XML.Name = "Subtitle_B1") Then frame_text_B1(ID_value) = XML.ReadInnerXml.ToString()
                    If (XML.Name = "Subtitle_B2") Then frame_text_B2(ID_value) = XML.ReadInnerXml.ToString()

                End If
            End While
            XML.Close() 'very important!!!


            'check if the project folder exists, since it might be copied/moved/replaced            
            If Not My.Computer.FileSystem.DirectoryExists(txt_ProjectDataPath.Text) Then
                'now check if project datafolder is in the same place as the project file (which is where it should be... always, these two belomg to each other like "Bassie & Adriaan" and must always stay together "Zie je Bassie gaan, dan komt Adriaan er aan."
                txt_ProjectDataPath.Text = Path.GetDirectoryName(OpenFileDialog.FileName) & "\" & Path.GetFileNameWithoutExtension(OpenFileDialog.FileName) & sst_datafoldernameend
                If My.Computer.FileSystem.DirectoryExists(txt_ProjectDataPath.Text) Then
                    MsgBox("Project datafolder path mismatch." & vbCrLf &
                           vbCrLf &
                           "The location of the project datafolder does not match the path as defined in the projectfile, the projectfile and its corresponding datafolder seem to have been moved." & vbCrLf &
                           vbCrLf &
                           "The new path has been detected and the project has been updated with new datafolder path. Please, save the project file to make these changes permanent. If this is not desired then exit now without saving.")
                Else
                    If MessageBox.Show("Error: the project folder is not in the same place as defined in the project file. Do you want to select a new location?", "Project folder not found", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                        FolderBrowserDialog.ShowNewFolderButton = False
                        FolderBrowserDialog.SelectedPath = Path.GetDirectoryName(OpenFileDialog.FileName)
                        If (FolderBrowserDialog.ShowDialog() = DialogResult.OK) Then
                            txt_ProjectDataPath.Text = FolderBrowserDialog.SelectedPath
                        End If
                    Else
                        Exit Sub
                    End If
                End If
            End If

            'Show_filenames_in_selected_folder() 'update the listbox
            project.available = True 'everything is loaded now, sow we may "release" the project
            EnableControls(Controls, True)     'enable the user interface
            txt_totalframes.Enabled = False     'this is the only field that should never be enabled (it just an indicator)

            numctrl_currentframe.Minimum = 1
            numctrl_currentframe.Maximum = Val(txt_totalframes.Text)
            numctrl_currentframe.Value = 1 'reset selection to the very first frame
            Debug.Print("load project")
            Load_image(numctrl_currentframe.Value)    'load the image
        Else
            MessageBox.Show("The filename you selected was not found.")
        End If

    End Sub

    ' Info regarding the use of external .EXE files:
    ' In order to use external .EXE files the programmer needs to add this file (and the files that are required to execute the .exe) should be added to the resources.
    ' My Project -> Resources Tab -> Add Resource DropDown -> Add Existing File. Select your .EXE here.
    ' Make sure that you also set the property of the just added resource, for setting "copy to ouput directory" is set to "Copy if newer"
    '
    'Exomizer.exe was download from: https://csdb.dk/release/?id=198340
    'PRG2TAP.EXE was downloaded from Luigi di Fraia's website https://www.luigidifraia.com/software/
    '
    Private Sub toolstrip_Export_to_TAP_file_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstrip_Export_to_TAP_file.Click
        Dim duration As Double
        Dim n_max As Integer

        Dim pgrBar As New frm_ProgressBar
        Dim n As Integer
        Dim firstcall As Boolean = True 'a simple flag to make sure that the question, "overwrite file OR append" will only be asked once
        Dim player_present = False      'a simple flag to indicate the presence of a player at the start of the TAP file, which indicates if we should append or overwrite when we encounter an existing file
        Dim image_OK As Boolean = False

        Dim p As New Diagnostics.Process()   'required for exomizer
        Dim PlayerSrcPath As String = txt_ProjectDataPath.Text & "\" & txt_PlayerFilename.Text     'the location of the unprocessed program file, as selected by the user
        Dim PlayerTmpPath As String = txt_ProjectDataPath.Text & "\Plr1.tmp"                       'the location of the processed program file (use the name .dat to make sure the user will not select it as a .prg sourcefile)
        Dim PlayerDstPath As String = txt_ProjectDataPath.Text & "\Plr2.tmp"                       'the location of the processed program file (use the name .dat to make sure the user will not select it as a .prg sourcefile)
        Dim ExomizerPath As String = Path.GetFullPath(Application.StartupPath & "\Resources\") & "exomizer.exe"    'The path to the exomizer application
        Dim prg2tapPath As String = Path.GetFullPath(Application.StartupPath & "\Resources\") & "prg2tap.exe" 'The path to the prg2tap application
        Dim TTL1Path As String = Path.GetFullPath(Application.StartupPath & "\Resources\") & "turboloader1.prg" 'The path to the prg2tap application
        Dim TTL2Path As String = Path.GetFullPath(Application.StartupPath & "\Resources\") & "turboloader2.prg" 'The path to the prg2tap application
        Dim SafeZoneOption As String

        'Dim watch As Stopwatch = Stopwatch.StartNew()

        If (project.available = False) Then
            MsgBox("Sorry, there is nothing to export...")
            Exit Sub
        End If

        Cursor = Cursors.WaitCursor 'notify user we're doing something

        '==============================================================================================================================================================
        'STEP 1: Save the current project, should anything go wrong duringthe build, at least we have the project so the user doesn't loose anything if they didn't save
        '--------------------------------------------------------------------------------------------------------------------------------------------------------------
        Save_projectsettings()  'save all settings, preventing possible loss of data in case the user forgets to save or the program (unexpectedly) crashes

        '==============================================================================================================================================================
        'Step 2: Handle the loader
        '--------------------------------------------------------------------------------------------------------------------------------------------------------------
        If ((chk_AddPlayerToOutput.Checked = True) And (My.Computer.FileSystem.FileExists(PlayerSrcPath) = True)) Then
            player_present = True
            If (chk_CompressLoaderFile.Checked = False) Then
                File.Copy(PlayerSrcPath, PlayerTmpPath, True)  'since we didn't compress the file, we make a unmodified copy if it which simplifies code below (as we only need to worry about one filename)
            Else
                p.StartInfo.UseShellExecute = False
                'p.StartInfo.RedirectStandardOutput = False
                p.StartInfo.RedirectStandardError = True
                p.StartInfo.CreateNoWindow = True
                p.StartInfo.FileName = ExomizerPath
                'Debug.Print("p.StartInfo.FileName = " & p.StartInfo.FileName)
                p.StartInfo.Arguments = " sfx sys """ & PlayerSrcPath & """ -o " & PlayerTmpPath
                'Debug.Print("p.StartInfo.Arguments = " & p.StartInfo.Arguments)
                p = Process.Start(p.StartInfo)
                'Debug.Print("output:" & p.StandardError.ReadToEnd())
                p.WaitForExit()
            End If


            p.StartInfo.UseShellExecute = False
            'p.StartInfo.RedirectStandardOutput = False
            p.StartInfo.RedirectStandardError = True
            p.StartInfo.CreateNoWindow = True
            p.StartInfo.FileName = prg2tapPath
            Debug.Print("p.StartInfo.FileName = " & p.StartInfo.FileName)


            '-s is responsible for adding 5 seconds of silence on the tape
            'This may improve the playback experience as the screen stays still
            'During that period, meaning the StripStream logo of the player is longer visible
            If (chk_AddSafeZone.Checked = False) Then
                SafeZoneOption = ""  'do not use the safezone option
            Else
                SafeZoneOption = "-s " 'do use the safezone option
            End If


            If (chk_UseFastloader.Checked = False) Then
                p.StartInfo.Arguments = " -n ""STRIPSTREAM"" " & SafeZoneOption & PlayerTmpPath & " " & PlayerDstPath     'Create a .TAP file using kernal loader, so that we load the StripStream player program as slow, but compatible as can be.
                'Debug.Print("p.StartInfo.Arguments = " & p.StartInfo.Arguments)
                p = Process.Start(p.StartInfo)
                'Debug.Print("output:" & p.StandardError.ReadToEnd())
                p.WaitForExit()
            Else
                p.StartInfo.Arguments = " -n ""STRIPSTREAM"" -p " & TTL1Path & " " & TTL2Path & " " & PlayerDstPath 'Create a .TAP file using the use TurboTape loader. This is much faster. In order to do so we must load the loader first
                'Debug.Print("p.StartInfo.Arguments = " & p.StartInfo.Arguments)
                p = Process.Start(p.StartInfo)
                'Debug.Print("output:" & p.StandardError.ReadToEnd())
                p.WaitForExit()

                p.StartInfo.Arguments = " -n ""STRIPSTREAM"" -t -a " & SafeZoneOption & PlayerTmpPath & " " & PlayerDstPath     'then we append to the TAP file we've just created, the program we intend to load, the StripStream player program
                'Debug.Print("p.StartInfo.Arguments = " & p.StartInfo.Arguments)                            
                p = Process.Start(p.StartInfo)
                'Debug.Print("output:" & p.StandardError.ReadToEnd())
                p.WaitForExit()
            End If

        End If

        '==============================================================================================================================================================
        'Step 3: Save the StripStream data
        '--------------------------------------------------------------------------------------------------------------------------------------------------------------

        SaveFileDialog.Title = "Generate a StripStream compatible TAP-file"
        SaveFileDialog.FileName = "StripStream_data.tap"
        SaveFileDialog.ValidateNames = False
        SaveFileDialog.Filter = "Tap files (*.TAP)|*.TAP|All files (*.*)|*.*"
        If (SaveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then


            'if a loader file is selected (.prg)
            'compress it (if compress tickbox is ticked) use EXOMIZER.EXE
            'convert it to a .TAP file use WAVPRG.EXE
            'if all succesfull copy the data of the loader program .TAP file

            clsStripStream.Statistics_clear()   'clear all statistical counters
            clsStripStream.header(SaveFileDialog.FileName)  'every TAP file start with a header


            If (player_present = True) Then      'a simple flag to indicate the presence of a player at the start of the TAP file, which indicates if we should append or overwrite when we encounter an existing file
                'copy the data from the previously generated .TAP file into the new StripStream TAP file
                clsStripStream.AddPlayerProgram(PlayerDstPath, SaveFileDialog.FileName)
            End If

            clsStripStream.Separator(SaveFileDialog.FileName, 320)  'draw a lot of separator bars to clear the screen

            n_max = Val(txt_totalframes.Text)
            pgrBar.Init("Processing frames", 0, n_max)
            pgrBar.Show()

            For n = 1 To n_max   'start with 1, because there is no frame:0
                pgrBar.Value(n)

                'many things are coupled to numctrl_currentframe, but we want to load the image without going through the event handler of numctrl_currentframe, so we disbaled it temporarily
                numctrl_currentframe_disablehandler = True
                numctrl_currentframe.Value = n
                numctrl_currentframe_disablehandler = False

                image_OK = Load_image(numctrl_currentframe.Value)    'load the image
                'watch.Start()

                'if the mode is "Centered", then we must also add extra separators BEFORE the image, in ordert to keep the image cleanly centered
                If (cmb_ImageAlign.SelectedIndex = 1) Then
                    clsStripStream.Separator(SaveFileDialog.FileName, (304 - pic_Dest.Image.Width) / 2)  'draw a separator bar between the previous and this image of ... lines wide
                End If

                'the meta data consume a lot of data and does not need to be send on every frame so it is spread across multiple frames
                If ((n Mod 5) = 0) Then clsStripStream.Series(SaveFileDialog.FileName, txt_series.Text)
                If ((n Mod 5) = 1) Then clsStripStream.Title(SaveFileDialog.FileName, txt_title.Text)
                If ((n Mod 5) = 2) Then clsStripStream.Author(SaveFileDialog.FileName, txt_author.Text)
                If ((n Mod 5) = 3) Then clsStripStream.Illustrator(SaveFileDialog.FileName, txt_illustrator.Text)
                If ((n Mod 5) = 4) Then clsStripStream.BuildInfo(SaveFileDialog.FileName, txt_buildby.Text, DateTime.Now.ToString("yyyy/MM/dd"))

                clsStripStream.ProgessBar(SaveFileDialog.FileName, n, n_max - n)
                clsStripStream.Subtitles(SaveFileDialog.FileName, 0, txt_subtitle_A1.Text, txt_subtitle_A2.Text)
                clsStripStream.Subtitles(SaveFileDialog.FileName, 1, txt_subtitle_B1.Text, txt_subtitle_B2.Text)

                If (image_OK = True) Then
                    clsStripStream.ImageLines(SaveFileDialog.FileName, pic_Dest.Image, 0, pic_Dest.Image.Width)

                    'if the mode is centered, then add extra separators until the image is centered
                    Select Case (cmb_ImageAlign.SelectedIndex)
                        Case 0  'Right
                            clsStripStream.Separator(SaveFileDialog.FileName, 8)  'draw a separator bar between the previous and this image of ... lines wide
                        Case 1  'Centered
                            clsStripStream.Separator(SaveFileDialog.FileName, ((304 - pic_Dest.Image.Width) / 2) + 8)  'draw a separator bar between the previous and this image of ... lines wide (+8 because of the invisble pixel area caused by scrolling)
                        Case 2  'Tight
                            'do not add any separators at all
                    End Select

                    'clsStripStream.Audio(SaveFileDialog.FileName)
                End If

                Select Case cmb_ImageAdvance.SelectedIndex
                    Case 0      'Keypress required to continue after each image
                        clsStripStream.Instruction(SaveFileDialog.FileName, "press key to continue")
                        clsStripStream.RequestToContinue(SaveFileDialog.FileName)   'this also clears the instruction text field when the user has pressed a key/button
                        clsStripStream.RestoreTapeSpeed(SaveFileDialog.FileName)    'a delay for ... sec. to let the datasette restore it's tape speed after being paused for an undertermined time

                    Case Else   'Scroll continuously (nothing can stop it)
                        'no special package needs to be send
                End Select

            Next n
            pgrBar.Dispose()

            'watch.Stop()
            'Debug.Print("Saving data took " & watch.Elapsed.TotalMilliseconds.ToString("F0") & " ms")
            'watch.Reset()

            duration = clsStripStream.Measure_duration(SaveFileDialog.FileName)
            Select Case cmb_Duration.SelectedItem
                Case "max. length 7:30"
                    If (duration > (7.5 * 60)) Then clsStripStream.Split(SaveFileDialog.FileName, (7.5 * 60))
                Case "max. length 15:00"
                    If (duration > (15 * 60)) Then clsStripStream.Split(SaveFileDialog.FileName, (15 * 60))
                Case "max. length 30:00"
                    If (duration > (30 * 60)) Then clsStripStream.Split(SaveFileDialog.FileName, (30 * 60))
                Case "max. length 45:00"
                    If (duration > (45 * 60)) Then clsStripStream.Split(SaveFileDialog.FileName, (45 * 60))
                Case "Split 50/50"
                    clsStripStream.Split(SaveFileDialog.FileName, (duration / 1.9)) 'split slightly past the middle otherwise we'd end of with 3 files (since we never split in the middle of a frame)
                Case "One big file"
                    'no splitting required
                Case Else
                    'no splitting required
            End Select

            clsStripStream.UpdateFilesizeInHeader(SaveFileDialog.FileName)  'now that we are done, we know the exact filesize, so we must write this info to the header

            Debug.Print("Size images                                                           = " & clsStripStream.Statistics_imagedatasize() & " Bytes")
            Debug.Print("Size text                                                             = " & clsStripStream.Statistics_textdatasize() & " Bytes")
            Debug.Print("Size metadata+progressbar+controlcodes)                               = " & (clsStripStream.Statistics_datasize() - clsStripStream.Statistics_imagedatasize() - clsStripStream.Statistics_textdatasize()) & " Bytes")
            Debug.Print("Total of all data (images, text, metadata, progressbar, controlcodes) = " & clsStripStream.Statistics_datasize() & " Bytes = " & clsStripStream.Statistics_datasize() \ 1024 & " kB")
            Debug.Print("Tape space wasted with syncpulses = " & clsStripStream.Statistics_syncsize() \ 60 & " min")

        Else
            MsgBox("Export operation has been cancelled")
        End If

        'clsStripStream.Statistics_huffman() 'present the frequency distribution of the used signals in percentages (used todetermine the order of bitpait signal frequencies
        Cursor = Cursors.Default    'return cursor back to normal
    End Sub

    Private Sub txt_subtitle_1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_subtitle_A1.TextChanged
        frame_text_A1(numctrl_currentframe.Value) = txt_subtitle_A1.Text
    End Sub

    Private Sub txt_subtitle_2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_subtitle_A2.TextChanged
        frame_text_A2(numctrl_currentframe.Value) = txt_subtitle_A2.Text
    End Sub

    Private Sub txt_subtitle_B1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_subtitle_B1.TextChanged
        frame_text_B1(numctrl_currentframe.Value) = txt_subtitle_B1.Text
    End Sub

    Private Sub txt_subtitle_B2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_subtitle_B2.TextChanged
        frame_text_B2(numctrl_currentframe.Value) = txt_subtitle_B2.Text
    End Sub

    'calculate how long the selected TAP file will take to be played back
    Private Sub MeasureTAPDurationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MeasureTAPDurationToolStripMenuItem.Click
        Dim duration As Double
        Dim minutes As String
        Dim seconds As String

        OpenFileDialog.Title = "Select .TAP file to be measured for duration"
        OpenFileDialog.Filter = "TAP files (*.TAP)|*.*TAP"
        OpenFileDialog.InitialDirectory = ""
        OpenFileDialog.FileName = ""
        If (OpenFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            duration = clsStripStream.Measure_duration(OpenFileDialog.FileName)
            minutes = Convert.ToInt32(duration \ 60).ToString
            seconds = Convert.ToInt32(duration Mod 60).ToString("D2")    'for seconds to have two decimal characters ("D2"), meaning that proceeding zeroes are added for values lower than 10
            MessageBox.Show(OpenFileDialog.FileName & " " & vbCrLf & vbCrLf & "Has a duration of " & minutes & ":" & seconds)
        Else
            MessageBox.Show("The filename you selected was not found.")
        End If
    End Sub

    'This will create a 35 minute TAP with only one single type of signal, a 3kHz pulse
    'This is intended for calibration purposes. A 35 minute duration will always be able to completely fill any 30min side of a 60min tape (even if the tape is a little bit longer)
    Private Sub Generate3kHzTAPToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Generate3kHzTAPToolStripMenuItem.Click
        Const DURATION As Integer = 35
        Dim pgrBar As New frm_ProgressBar

        SaveFileDialog.Title = "Generate a 3kHz TAP testfile"
        SaveFileDialog.FileName = "Testtone_3kHz.tap"
        SaveFileDialog.ValidateNames = False
        SaveFileDialog.Filter = "Tap files (*.TAP)|*.TAP|All files (*.*)|*.*"
        If (SaveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            pgrBar.Init("Generating testfile", 0, DURATION)
            pgrBar.Show()
            clsStripStream.header(SaveFileDialog.FileName)  'every TAP file start with a header
            For i = 1 To DURATION
                clsStripStream.TestTAP_TestFreq(SaveFileDialog.FileName)    'generate the required signal
                pgrBar.Value(i)
            Next i
            pgrBar.Dispose()
        End If
    End Sub

    'This will create a .. minute TAP file with only one single type of signal, a frequency sweep between the min and max pulse signals
    Private Sub GeneratefreqSweepTAPToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GeneratefreqSweepTAPToolStripMenuItem.Click
        Const DURATION As Integer = 35
        Dim pgrBar As New frm_ProgressBar

        SaveFileDialog.Title = "Generate a freq. sweep TAP testfile"
        SaveFileDialog.FileName = "Test_freqsweep.tap"
        SaveFileDialog.ValidateNames = False
        SaveFileDialog.Filter = "Tap files (*.TAP)|*.TAP|All files (*.*)|*.*"
        If (SaveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            pgrBar.Init("Generating testfile", 0, DURATION)
            pgrBar.Show()
            clsStripStream.header(SaveFileDialog.FileName)  'every TAP file start with a header
            For i = 1 To DURATION
                clsStripStream.Testfreqsweep(SaveFileDialog.FileName)    'generate the required signal
                pgrBar.Value(i)
            Next i
            pgrBar.Dispose()
        End If
    End Sub

    Private Sub btn_AddBefore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_AddBefore.Click
        Dim i As Integer

        'increment array
        txt_totalframes.Text = Val(txt_totalframes.Text) + 1    'increment total number of frame in this project
        Redim_ProjectArrays(Val(txt_totalframes.Text))          'create an array that fits the amount of data we might require for this project

        'copy anything from the current frame up to and including the last frame one frame index further
        'Debug.Print("Val(txt_totalframes.Text)=" & Val(txt_totalframes.Text))
        'Debug.Print("numctrl_currentframe.Value=" & numctrl_currentframe.Value)
        For i = Val(txt_totalframes.Text) To numctrl_currentframe.Value Step -1
            frame_text_A1(i) = frame_text_A1(i - 1)
            frame_text_A2(i) = frame_text_A2(i - 1)
            frame_text_B1(i) = frame_text_B1(i - 1)
            frame_text_B2(i) = frame_text_B2(i - 1)
            'Debug.Print("frame_imagefilename(" & i & ")=" & frame_imagefilename(i) & ", frame_imagefilename(" & i - 1 & ")=" & frame_imagefilename(i - 1))
            frame_imagefilename(i) = frame_imagefilename(i - 1)
            frame_contrast(i) = frame_contrast(i - 1)
            frame_brightness(i) = frame_brightness(i - 1)
            frame_thresshold(i) = frame_thresshold(i - 1)
            frame_advance(i) = frame_advance(i - 1)
            frame_align(i) = frame_align(i - 1)
        Next

        'define contents of newly added frame
        frame_text_A1(numctrl_currentframe.Value) = default_subtitle_text_1
        frame_text_A2(numctrl_currentframe.Value) = default_subtitle_text_2
        frame_text_B1(numctrl_currentframe.Value) = default_subtitle_text_1
        frame_text_B2(numctrl_currentframe.Value) = default_subtitle_text_2
        frame_imagefilename(numctrl_currentframe.Value) = default_imagefilename
        frame_contrast(numctrl_currentframe.Value) = default_contrast
        frame_brightness(numctrl_currentframe.Value) = default_brightness
        frame_thresshold(numctrl_currentframe.Value) = default_thresshold
        frame_advance(numctrl_currentframe.Value) = default_advance
        frame_align(numctrl_currentframe.Value) = default_align

        'update the screen
        numctrl_currentframe.Maximum = Val(txt_totalframes.Text)
        Load_image(numctrl_currentframe.Value)    'load the image
    End Sub

    Private Sub btn_AddAfter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_AddAfter.Click
        Addframe()
    End Sub

    Private Sub Addframe()
        Dim i As Integer

        'increment array
        txt_totalframes.Text = Val(txt_totalframes.Text) + 1    'increment total number of frame in this project
        Redim_ProjectArrays(Val(txt_totalframes.Text))          'create an array that fits the amount of data we might require for this project

        'copy anything from the current frame up to and including the last frame one frame index further
        'Debug.Print("Val(txt_totalframes.Text)=" & Val(txt_totalframes.Text))
        'Debug.Print("numctrl_currentframe.Value=" & numctrl_currentframe.Value)
        For i = Val(txt_totalframes.Text) To (numctrl_currentframe.Value + 1) Step -1
            frame_text_A1(i) = frame_text_A1(i - 1)
            frame_text_A2(i) = frame_text_A2(i - 1)
            frame_text_B1(i) = frame_text_B1(i - 1)
            frame_text_B2(i) = frame_text_B2(i - 1)
            'Debug.Print("frame_imagefilename(" & i & ")=" & frame_imagefilename(i) & ", frame_imagefilename(" & i - 1 & ")=" & frame_imagefilename(i - 1))
            frame_imagefilename(i) = frame_imagefilename(i - 1)
            frame_contrast(i) = frame_contrast(i - 1)
            frame_brightness(i) = frame_brightness(i - 1)
            frame_thresshold(i) = frame_thresshold(i - 1)
            frame_advance(i) = frame_advance(i - 1)
            frame_align(i) = frame_align(i - 1)
        Next

        'define contents of newly added frame
        frame_text_A1(numctrl_currentframe.Value + 1) = default_subtitle_text_1
        frame_text_A2(numctrl_currentframe.Value + 1) = default_subtitle_text_2
        frame_text_B1(numctrl_currentframe.Value + 1) = default_subtitle_text_1
        frame_text_B2(numctrl_currentframe.Value + 1) = default_subtitle_text_2
        frame_imagefilename(numctrl_currentframe.Value + 1) = default_imagefilename
        frame_contrast(numctrl_currentframe.Value + 1) = default_contrast
        frame_brightness(numctrl_currentframe.Value + 1) = default_brightness
        frame_thresshold(numctrl_currentframe.Value + 1) = default_thresshold
        frame_advance(numctrl_currentframe.Value + 1) = default_advance
        frame_align(numctrl_currentframe.Value + 1) = default_align

        'update the screen
        numctrl_currentframe.Maximum = Val(txt_totalframes.Text)
        numctrl_currentframe.Value = numctrl_currentframe.Value + 1 'this also triggers a reload of the image
        'Load_image(numctrl_currentframe.Value)    'load the image
    End Sub

    Private Sub btn_DeleteFrame_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DeleteFrame.Click
        If (Val(txt_totalframes.Text) > 1) Then 'perform only if possible AND if the user really wants to delete the current frame...
            If MessageBox.Show("Are you sure you want to delete this frame?", "Delete frame?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then

                'copy anything after the current frame up to and including the last frame one frame index lower
                Dim i As Integer

                'copy anything from the current frame up to and including the last frame one frame index further
                Debug.Print("Val(txt_totalframes.Text)=" & Val(txt_totalframes.Text))
                Debug.Print("numctrl_currentframe.Value=" & numctrl_currentframe.Value)
                For i = (numctrl_currentframe.Value + 1) To Val(txt_totalframes.Text)
                    frame_text_A1(i - 1) = frame_text_A1(i)
                    frame_text_A2(i - 1) = frame_text_A2(i)
                    frame_text_B1(i - 1) = frame_text_B1(i)
                    frame_text_B2(i - 1) = frame_text_B2(i)
                    'Debug.Print("frame_imagefilename(" & i-1 & ")=" & frame_imagefilename(i-1) & ", frame_imagefilename(" & i & ")=" & frame_imagefilename(i))
                    frame_imagefilename(i - 1) = frame_imagefilename(i)
                    frame_contrast(i - 1) = frame_contrast(i)
                    frame_brightness(i - 1) = frame_brightness(i)
                    frame_thresshold(i - 1) = frame_thresshold(i)
                    frame_advance(i - 1) = frame_advance(i)
                    frame_align(i - 1) = frame_align(i)
                Next

                'decrement array
                txt_totalframes.Text = Val(txt_totalframes.Text) - 1    'increment total number of frame in this project
                Redim_ProjectArrays(Val(txt_totalframes.Text))          'create an array that fits the amount of data we might require for this project

                'update the screen
                numctrl_currentframe.Maximum = Val(txt_totalframes.Text)
                Load_image(numctrl_currentframe.Value)    'load the image
                UpdateAll()

            End If
        End If
    End Sub

    Private Sub btn_ImageSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ImageSelect.Click
        OpenFileDialog.Title = "Select image for frame" & numctrl_currentframe.Value
        OpenFileDialog.Filter = "Image files (*.jpg)|*.*jpg"
        OpenFileDialog.InitialDirectory = txt_ProjectDataPath.Text
        OpenFileDialog.FileName = ""
        If (OpenFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            'Debug.Print("selected file: " & OpenFileDialog.SafeFileName) 'safefilename get's the file without the path

            If (txt_ProjectDataPath.Text <> Path.GetDirectoryName(OpenFileDialog.FileName)) Then
                If MessageBox.Show("The use of files outside the datafolder is not allowed. Do you want to make a copy of the selected file to the project folder and use the copy?", "Copy file to project folder?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                    'copy file to project folder
                    If My.Computer.FileSystem.FileExists(txt_ProjectDataPath.Text & "\" & OpenFileDialog.SafeFileName) Then
                        If MessageBox.Show("Error: there is a file with the same name in that folder. Do you want to replace it?", "Overwrite existing file in project folder?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                            File.Copy(OpenFileDialog.FileName, txt_ProjectDataPath.Text & "\" & OpenFileDialog.SafeFileName, True)
                        Else
                            Exit Sub
                        End If
                    Else
                        File.Copy(OpenFileDialog.FileName, txt_ProjectDataPath.Text & "\" & OpenFileDialog.SafeFileName)
                    End If
                Else
                    Exit Sub
                End If
            End If
        frame_imagefilename(numctrl_currentframe.Value) = OpenFileDialog.SafeFileName
        Debug.Print("image select clicked")
        Load_image(numctrl_currentframe.Value)    'load the image                

        End If
    End Sub

    'A StripStream player file is the program that is required on the C64 to playback the StripStream data
    'without a player, the dataset is useless. Although it is a good practice to store the player onto the
    'same tape as the data, this may not always be desired.
    Private Sub btn_PlayerSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_PlayerSelect.Click
        OpenFileDialog.Title = "Select player .PRG file" & numctrl_currentframe.Value
        OpenFileDialog.Filter = "PRG files (*.prg)|*.*prg"
        Debug.Print("txt_ProjectDataPath.Text = " & txt_ProjectDataPath.Text)
        OpenFileDialog.InitialDirectory = txt_ProjectDataPath.Text
        OpenFileDialog.FileName = ""
        If (OpenFileDialog.ShowDialog = Windows.Forms.DialogResult.OK) Then
            'Debug.Print("selected file: " & OpenFileDialog.SafeFileName) 'safefilename get's the file without the path

            If (txt_ProjectDataPath.Text <> Path.GetDirectoryName(OpenFileDialog.FileName)) Then
                If MessageBox.Show("The use of files outside the datafolder is not allowed. Do you want to make a copy of the selected file to the project folder and use the copy?", "Copy file to project folder?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                    'copy file to project folder
                    If My.Computer.FileSystem.FileExists(txt_ProjectDataPath.Text & "\" & OpenFileDialog.SafeFileName) Then
                        If MessageBox.Show("Error: there is a file with the same name in that folder. Do you want to replace it?", "Overwrite existing file in project folder?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                            File.Copy(OpenFileDialog.FileName, txt_ProjectDataPath.Text & "\" & OpenFileDialog.SafeFileName, True)
                        Else
                            Exit Sub
                        End If
                    Else
                        File.Copy(OpenFileDialog.FileName, txt_ProjectDataPath.Text & "\" & OpenFileDialog.SafeFileName)
                    End If
                Else
                    Exit Sub
                End If
            End If
            txt_PlayerFilename.Text = OpenFileDialog.SafeFileName
        End If
    End Sub

    Private Sub btn_default_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_default.Click
        trk_Contrast.Value = default_contrast
        trk_Brightness.Value = default_brightness
        trk_Thresshold.Value = default_thresshold

        frame_contrast(numctrl_currentframe.Value) = trk_Contrast.Value
        frame_brightness(numctrl_currentframe.Value) = trk_Brightness.Value
        frame_thresshold(numctrl_currentframe.Value) = trk_Thresshold.Value

        UpdateAll()
    End Sub

    Private Sub btn_refresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_refresh.Click
        Debug.Print("refresh")
        Load_image(numctrl_currentframe.Value)    'load the image
    End Sub

    Private Sub cmb_ImageAdvance_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_ImageAdvance.SelectedIndexChanged
        If (project.available = True) Then
            frame_advance(numctrl_currentframe.Value) = cmb_ImageAdvance.SelectedIndex
        End If
    End Sub

    Private Sub cmb_ImageAlign_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_ImageAlign.SelectedIndexChanged
        If (project.available = True) Then
            frame_align(numctrl_currentframe.Value) = cmb_ImageAlign.SelectedIndex
        End If
    End Sub

    Private Sub contrast_and_brightness(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trk_Contrast.Scroll, trk_Brightness.Scroll
        If (project.available = True) Then
            If Not (pic_Source.Image Is Nothing) Then   'only allow contrast and/or brightness to change when there is an image to work with
                pic_Source.Image = clsImgConversion.ChangeBrightnessContrast(SourceImage, trk_Brightness.Value, trk_Contrast.Value)
                frame_contrast(numctrl_currentframe.Value) = trk_Contrast.Value
                frame_brightness(numctrl_currentframe.Value) = trk_Brightness.Value
                UpdateAll()
            End If
        End If
    End Sub

    Private Sub trk_Thresshold_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trk_Thresshold.Scroll
        If (project.available = True) Then
            frame_thresshold(numctrl_currentframe.Value) = trk_Thresshold.Value
            UpdateAll()
        End If
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem1.Click
        MsgBox(
           "StripStream is created by Jan Derogee" & vbCrLf &
           "Version 1.0 (build date: 2023-03-26)" & vbCrLf & vbCrLf & vbCrLf &
           "" & vbCrLf &
           "Special thanks to the people who made my life easier" & vbCrLf &
           "by writing two great tools. Tools that allowed me to" & vbCrLf &
           "easily combine the stripstream player program with" & vbCrLf &
           "the stripstream datafile. This allows for a single .TAP" & vbCrLf &
           "file holding both the player and the data. This way" & vbCrLf &
           "users can simply drop the .TAP file in an emulator and" & vbCrLf &
           "enjoy the show." & vbCrLf &
           "" & vbCrLf &
           " - Zagon, for making exomizer.exe" & vbCrLf &
           " - Luigi di Fraia, for making prg2tap.exe")
    End Sub
End Class



'===================================== obsolete code ============================================


'Dim duration As Double
'Dim minutes As String
'Dim seconds As String
'duration = clsStripStream.Measure_duration(txt_ProjectDataPath.Text & "\" & OpenFileDialog.SafeFileName)
'minutes = Convert.ToInt32(duration \ 60).ToString
'seconds = Convert.ToInt32(duration Mod 60).ToString("D2")    'for seconds to have two decimal characters ("D2"), meaning that proceeding zeroes are added for values lower than 10
'Debug.Print(OpenFileDialog.FileName & " has a duration of " & minutes & ":" & seconds)


'Private Function Show_filenames_in_selected_folder() As Long
'    Dim str_EntryInFolder As String
'    Dim str_arr_FilesInFolder As String()
'    Dim lp As Integer = 0

'    Debug.Print("txt_ProjectDataPath.text = " & txt_ProjectDataPath.text)

'    'this piece of code searches for files in the specified path
'    Try
'        str_arr_FilesInFolder = Directory.GetFiles(txt_ProjectDataPath.text, "*.jpg")       'Only get files that end with "*.jpg"
'        lst_Batch.Items.Clear()   'clear listbox
'        For Each str_EntryInFolder In str_arr_FilesInFolder
'            str_EntryInFolder = Replace(str_EntryInFolder, txt_ProjectDataPath.text, "")    'remove the path, leaving only the pure filename (which is exactly what we want)
'            str_EntryInFolder = Replace(str_EntryInFolder, "\", "")         'remove the \, (if there is any) leaving only the pure filename (which is exactly what we want)
'            lst_Batch.Items.Add(str_EntryInFolder)                          'print to the screen, showing the results of the search action
'            lp = lp + 1
'        Next

'    Catch ex As Exception
'        MsgBox("Ehhhmmm, something went wrong...")
'    End Try
'    Show_filenames_in_selected_folder = lp      'return the number of file (frames) in this folder
'End Function

